#include <stdio.h>
#include <stdlib.h>
/*
#include <math.h>
*/

int iter[24], m, j4, max24, E[96], F[96], IR[1001], 
   IX[1001], ZONE[300];

double A11, A12, A13, A21, A22, A23, A31, A32, A33, CO, 
   DK, DM22, DM23, DM24, DM25, DM26, DM27, DM28, FLX, Q, R, S, SIG, 
   STB5, T;

double B5[101], D[300], DEX[1001], DEX1[1001], EX[1001], 
   EX1[1001], G[1001], GRD[1001], PLAN[300], RH[1001], RX[1001], SA[101], 
   SB[101], VE3[101], VLIN[101], VLR[101], VSP[101], VSTP[101], VX[1001], 
   VXND[101], VXNE[101], XI[1001], XX[1001], U[1001], V[1001], W[1001], 
   X[1001], Y[1001], Z[1001];

double B[64][64], C[64][64], H[64][64], P[4][512], 
   CX[25][101], PX[25][101], U1[5][101][2], U2[5][101][2], U3[5][101][2], 
   VF[101][7], VG[101][7], VH[101][7], VS[101][7], VY[101][25], ZA[101][7], 
   ZB[101][7], ZM[101][7], ZP[101][7], ZQ[101][7], ZR[101][7], ZU[101][7], 
   ZV[101][7], ZZ[101][7];

#define LINE_SIZE		80

#define TRUE			1
#define FALSE			0

#define max(a,b)		(((a)>(b))?(a):(b))
#define min(a,b)		(((a)<(b))?(a):(b))
#define abs(a)			(((a)>(0))?(a):(-a))
/* #define sgn(a)		(((a)>0)?1:(((a)<0)?(-1):0)) */

void Loop1(int n);  void Loop2(int n);  void Loop3(int n);
void Loop4(int n);  void Loop5(int n);  void Loop6(int n);
void Loop7(int n);  void Loop8(int n);  void Loop9(int n);
void Loop10(int n); void Loop11(int n); void Loop12(int n);
void Loop13(int n); void Loop14(int n); void Loop15(int n);
void Loop16(int n); void Loop17(int n); void Loop18(int n);
void Loop19(int n); void Loop20(int n); void Loop21(int n);
void Loop22(int n); void Loop23(int n); void Loop24(int n);

void wrinput1(FILE *fp);  void wrinput2(FILE *fp);  void wrinput3(FILE *fp);
void wrinput4(FILE *fp);  void wrinput5(FILE *fp);  void wrinput6(FILE *fp);
void wrinput7(FILE *fp);  void wrinput8(FILE *fp);  void wrinput9(FILE *fp);
void wrinput10(FILE *fp); void wrinput11(FILE *fp); void wrinput12(FILE *fp);
void wrinput13(FILE *fp); void wrinput14(FILE *fp); void wrinput15(FILE *fp);
void wrinput16(FILE *fp); void wrinput17(FILE *fp); void wrinput18(FILE *fp);
void wrinput19(FILE *fp); void wrinput20(FILE *fp); void wrinput21(FILE *fp);
void wrinput22(FILE *fp); void wrinput23(FILE *fp); void wrinput24(FILE *fp);

void wroutput1(FILE *fp);  void wroutput2(FILE *fp);  void wroutput3(FILE *fp);
void wroutput4(FILE *fp);  void wroutput5(FILE *fp);  void wroutput6(FILE *fp);
void wroutput7(FILE *fp);  void wroutput8(FILE *fp);  void wroutput9(FILE *fp);
void wroutput10(FILE *fp); void wroutput11(FILE *fp); void wroutput12(FILE *fp);
void wroutput13(FILE *fp); void wroutput14(FILE *fp); void wroutput15(FILE *fp);
void wroutput16(FILE *fp); void wroutput17(FILE *fp); void wroutput18(FILE *fp);
void wroutput19(FILE *fp); void wroutput20(FILE *fp); void wroutput21(FILE *fp);
void wroutput22(FILE *fp); void wroutput23(FILE *fp); void wroutput24(FILE *fp);

int sgn(double a);
double sq(double r);
int MOD2N(int i,int j);
void initial(int n);
void vector(void);
void wrinput(int loop);
void wr3wideflt(FILE *fp, int cnt, double array[]);
void wroutput(int loop);
void open_error(char *fname);
void new_wrin_func(int loop, FILE *fp);
void new_loop_func(int loop, int n);
void new_wrout_func(int loop, FILE *fp);

double exp(double x);
double sqrt(double x);

void main(int argc,char *argv[])
{
   int loop;
   int keep_files;
   /* int (*loop_func)(); */
   char buff[LINE_SIZE];


   
printf ("Do you wish to create input/output files? [y/n]:  ");
   gets (buff);
   if (buff[0] == 'Y'  ||  buff[0] == 'y') keep_files = TRUE;
   else keep_files = FALSE;

   do {
      printf ("Which loop:  ");
      gets (buff);
      sscanf (buff, "%d", &loop);

      if (loop < 1  ||	loop > 24) break;

      initial (loop);
      if (keep_files) wrinput (loop);

/*
      loop_func = loop_fcn[loop-1];
      loop_func (iter[loop-1]);
*/
      new_loop_func(loop-1, iter[loop-1]);  /* replace above indirect call */
      
      if (keep_files) wroutput (loop);

   } while (TRUE);
}

void Loop1(int n)
{
   int k;
   for (k = 0; k < n; k++) {
      X[k] = Q + (Y[k] * ((R * Z[k+10]) + (T * Z[k+11])));
   }
} 

void Loop2(int n)
{
   int k,i,IL,IPNT,IPNTP;

   IL = n;
   IPNTP = 0;

   do {
      IPNT = IPNTP;
      IPNTP += IL;
      IL /= 2;
      i = IPNTP;

      for (k = IPNT+1; k < IPNTP; k += 2) {
	 X[i++] = X[k] - (V[k] * X[k-1]) + (V[k+1] * X[k+1]);
      }

   } while (IL > 1);
} 

void Loop3(int n)
{
   int k;
   Q = 0.0;

   for (k = 0; k < n; k++) {
      Q += Z[k] * X[k];
   }
} 


void Loop4(int n)
{
   int k,j,lw;

   for (k = 6; k < 1001; k += (1001 - 7)/2) {
      lw = k - 6;

      for (j = 4; j < n; j += 5) {
	 X[k-1] -= X[lw++] * Y[j];
      }

      X[k-1] *= Y[4];
   }
} 


void Loop5(int n)
{
   int i;

   for (i = 1; i < n; i++) {
     X[i] = Z[i] * (Y[i] - X[i-1]);
   }
} 


void Loop6(int n)
{
   int i,k;

   for (i = 1; i < n; i++) {
      for (k = 0; k < i; k++) {
	 W[i] += B[i][k] * W[i-k-1];
      }
   }
} 

void Loop7(int n)
{
   int k;

   for (k = 0; k < n; k++) {
      X[k] = U[k] +
	(R * (Z[k]   + (R *  Y[k]))) +
	(T * (U[k+3] + (R * (U[k+2] + (R * U[k+1])))
      + (T * (U[k+6] + (R * (U[k+5] + (R * U[k+4])))))));
   }
} 

void Loop8(int n)
{
   int kx,ky,nl1,nl2;
   double DU1[101],DU2[101],DU3[101];

      nl1 = 0;
      nl2 = 1;
      for (kx = 1; kx < 3; kx++) {
	 for (ky = 1; ky < n; ky++) {
	    DU1[ky] = U1[kx][ky+1][nl1] - U1[kx][ky-1][nl1];
	    DU2[ky] = U2[kx][ky+1][nl1] - U2[kx][ky-1][nl1];
	    DU3[ky] = U3[kx][ky+1][nl1] - U3[kx][ky-1][nl1];

	    U1[kx][ky][nl2] = U1[kx][ky][nl1] + (A11 * DU1[ky]) + (A12 *
	     DU2[ky]) + (A13 * DU3[ky]) + (SIG * (U1[kx+1][ky][nl1] -
	     (2.0 * U1[kx][ky][nl1]) + U1[kx-1][ky][nl1]));

	    U2[kx][ky][nl2] = U2[kx][ky][nl1] + (A21 * DU1[ky]) + (A22 *
	     DU2[ky]) + (A23 * DU3[ky]) + (SIG * (U2[kx+1][ky][nl1] -
	     (2.0 * U2[kx][ky][nl1]) + U2[kx-1][ky][nl1]));

	    U3[kx][ky][nl2] = U3[kx][ky][nl1] + (A31 * DU1[ky]) + (A32 *
	     DU2[ky]) + (A33 * DU3[ky]) + (SIG * (U3[kx+1][ky][nl1] -
	    (2.0 * U3[kx][ky][nl1]) + U3[kx-1][ky][nl1]));
      }
   }
} 

void Loop9(int n)
{
   int i;

   for (i = 0; i < n; i++) {
      PX[0][i] = PX[2][i] +  (CO * (PX[4][i] + PX[5][i])) +
	       (DM28 * PX[12][i]) + (DM27 * PX[11][i]) +
	       (DM26 * PX[10][i]) + (DM25 * PX[9][i]) +
	       (DM24 * PX[8][i])  + (DM23 * PX[7][i])  + 
	       (DM22 * PX[6][i]);
   }
} 

void Loop10(int n)
{
   int i;
   double AR,BR,CR;

   for (i = 0; i < n; i++) {
      AR = CX[4][i];
      BR = AR - PX[4][i];
      PX[4][i] = AR;
      CR = BR - PX[5][i];
      PX[5][i] = BR;
      AR = CR - PX[6][i];
      PX[6][i] = CR;
      BR = AR - PX[7][i];
      PX[7][i] = AR;
      CR = BR - PX[8][i];
      PX[8][i] = BR;
      AR = CR - PX[9][i];
      PX[9][i] = CR;
      BR = AR - PX[10][i];
      PX[10][i] = AR;
      CR = BR - PX[11][i];
      PX[11][i] = BR;
      PX[13][i] = CR - PX[12][i];
      PX[12][i] = CR;
   }
} 

void Loop11(int n)
{
   int k;

   X[0] = Y[0];

   for (k = 1; k < n; k++) {
      X[k] = X[k-1] + Y[k];
   }
} 

void Loop12(int n)
{
   int k;

   for (k = 0; k < n; k++) {
      X[k] = Y[k+1] - Y[k];
   }
} 

void Loop13(int n)
{
   int ip,i1,j1,i2,j2;

   for (ip = 0; ip < n; ip++) {
      i1 = P[0][ip];
      j1 = P[1][ip];
      i1 = MOD2N(i1,64);
      j1 = MOD2N(j1,64);
      P[2][ip] += B[i1][j1];
      P[3][ip] += C[i1][j1];
      P[0][ip] += P[2][ip];
      P[1][ip] += P[3][ip];
      i2 = P[0][ip];
      j2 = P[1][ip];
      i2 = MOD2N(i2,64) - 1;
      j2 = MOD2N(j2,64) - 1;
      P[0][ip] += Y[i2+32];
      P[1][ip] += Z[j2+32];
      i2 += E[i2+32] - 1;
      j2 += F[j2+32] - 1;
      H[i2][j2] += 1.0;
   }
} 


void Loop14(int n)
{
   int k;

   for (k = 0; k < n; k++) {
      VX[k] = 0.0;
      XX[k] = 0.0;
      IX[k] = GRD[k];
      XI[k] = IX[k];
      EX1[k] = EX[IX[k]-1];
      DEX1[k] = DEX[IX[k]-1];
   }

   for (k = 0; k < n; k++) {
      VX[k] += EX1[k] + (DEX1[k] * (XX[k] - XI[k]));
      XX[k] += VX[k] + FLX;
      IR[k] = XX[k];
      RX[k] = XX[k] - IR[k];
      IR[k] = MOD2N(IR[k],512) + 1;
      XX[k] = RX[k] + IR[k];
   }

   for (k = 0; k < n; k++) {
      RH[IR[k]-1] += 1.0 - RX[k];
      RH[IR[k]] += RX[k];
   } 
} 

void Loop15(int n)
{
   int j,k;
   double R,S,T;

   for (j = 1; j < 7; j++) {
      for (k = 1; k < n; k++) {

	 if (j >= 6) {
	    VY[k][j] = 0.0;
	    continue;
	 }
	 else if (VH[k][j+1] > VH[k][j]) T = 0.053;
	 else T = 0.073;

	 if (VF[k][j] < VF[k-1][j]) {
	    R = max (VH[k-1][j], VH[k-1][j+1]);
	    S = VF[k-1][j];
	 }
	 else {
	    R = max (VH[k][j], VH[k][j+1]);
	    S = VF[k][j];
	 }

	 VY[k][j] = sqrt( sq (VG[k][j]) + R * R) * T / S;

	 if (k >= n-1) {
	    VS[k][j] = 0.0;
	    continue;
	 }
	 else if (VF[k][j] < VF[k][j-1]) {
	    R = max (VG[k][j-1], VG[k+1][j-1]);
	    S = VF[k][j-1];
	    T = 0.073;
	 }
	 else {
	    R = max (VG[k][j], VG[k+1][j]);
	    S = VF[k][j];
	    T = 0.053;
	 }

	 VS[k][j] = sqrt( sq (VH[k][j]) + R * R) * T / S;
      }
   }
} 

void Loop16(int n)
{
   int i1,j2,j5,k,II,LB;
   int sign;

   m = 1;
   i1 = m;
   II = n / 3;
   LB = II + II;

   do {
      j2 = (n + n) * (m - 1) + 1;

      for (k = 0; k < n; k++) {
	 j4 = j2 + k + k;
	 j5 = ZONE[j4+1];

	 if (j5 < n)
	    if (j5 >= n - LB)
	       if (j5 >= n - II) sign = sgn (PLAN[j5-1] - R);
	       else sign = sgn (PLAN[j5-1] - S);
	    else sign = sgn (PLAN[j5-1] - T);

	 else if (j5 > n) sign = sgn (D[j5-1] - (D[j5-2] * sq (T - D[j5-3])
	  + sq (S - D[j5-4]) + sq (R - D[j5-5])));

	 else sign = 0;

	 sign *= sgn (ZONE[j4]);

	 if (sign == 0) return;
	 else if (sign < 0) {
	    if (++m > ZONE[0]) m = 1;
	    if (i1 != m) break;
	    else return;
	 }
      }
   } while (TRUE);
}

void Loop17(int n)
{
   int i;
   double E3,E6, XNC,XNEI,XNM;

   i = n-1;
   XNM = 1.0 / 3.0;
   E6 = 1.03 / 3.07;

   do {
      E3 = XNM * VLR[i] + VLIN[i];
      XNC = 5.0 / 3.0 * E3;
      XNEI = VXNE[i];
      VXND[i] = E6;

      if (XNM > XNC  ||	 XNEI > XNC) {
	 E6 = XNM * VSP[i] + VSTP[i];
	 VXNE[i] = E6;
	 XNM = E6;
	 VE3[i] = E6;
      }
      else {
	 VE3[i] = E3;
	 E6 = E3 + E3 - XNM;
	 VXNE[i] = E3 + E3 - XNEI;
	 XNM = E6;
      }
   } while (--i != 0);
} 

void Loop18(int n)
{
   int k,j;

   for (k = 1; k < 6; k++) {
      for (j = 1; j < n; j++) {
	 ZA[j][k] =
	(ZP[j-1][k+1] + ZQ[j-1][k+1] - ZP[j-1][k] - ZQ[j-1][k]) *
	(ZR[j][k] + ZR[j-1][k]) / (ZM[j-1][k] + ZM[j-1][k+1]);

	 ZB[j][k] = 
	(ZP[j-1][k] + ZQ[j-1][k] - ZP[j][k] - ZQ[j][k]) *
	(ZR[j][k] + ZR[j][k-1]) / (ZM[j][k] + ZM[j-1][k]);
      }
   }

   for (k = 1; k < 6; k++) {
      for (j = 1; j < n; j++) {
	 ZU[j][k] += S *
		  (ZA[j][k]   * (ZZ[j][k] - ZZ[j+1][k]) -
		   ZA[j-1][k] * (ZZ[j][k] - ZZ[j-1][k]) -
		   ZB[j][k]   * (ZZ[j][k] - ZZ[j][k-1]) +
		   ZB[j][k+1] * (ZZ[j][k] - ZZ[j][k+1]));

	 ZV[j][k] += S *
		  (ZA[j][k]   * (ZR[j][k] - ZR[j+1][k]) -
		   ZA[j-1][k] * (ZR[j][k] - ZR[j-1][k]) -
		   ZB[j][k]   * (ZR[j][k] - ZR[j][k-1]) +
		   ZB[j][k+1] * (ZR[j][k] - ZR[j][k+1]));
      }
   }

   for (k = 1; k < 6; k++) {
      for (j = 1; j < n; j++) {
	 ZR[j][k] += T * ZU[j][k];
	 ZZ[j][k] += T * ZV[j][k];
      }
   }
} 

void Loop19(int n)
{
  int i,k;

   for (k = 0; k < n; k++) {
      B5[k] = SA[k] + STB5 * SB[k];
      STB5 = B5[k] - STB5;
   }

   for (i = 0; i < n; i++) {
      k = n - i - 1;
      B5[k] = SA[k] + STB5 * SB[k];
      STB5 = B5[k] - STB5;
   }
}


void Loop20(int n)
{
   int k;
   double DI,DN;

   for (k = 0; k < n; k++) {
      DI = Y[k] - (G[k] / (XX[k] + DK));
      DN = 0.2;

      if (DI != 0.0) DN = max (S, min (Z[k]/DI, T) );

      X[k] = ((W[k] + V[k] * DN) * XX[k] + U[k]) / (VX[k] + V[k] * DN);
      XX[k+1] = (X[k] - XX[k]) * DN + XX[k];
   }
}

void Loop21(int n)
{
   int i,j,k;

   for (k = 0; k < 15; k++)
      for (i = 0; i < 15; i++)
	 for (j = 0; j < n; j++)
	    PX[i][j] += VY[i][k] * CX[k][j];
}

void Loop22(int n)
{
   int k;

   for (k = 0; k < n; k++) {
      Y[k] = 20.0;
      if (U[k] < 20.0 * V[k]) Y[k] = U[k] / V[k];
      W[k] = X[k] / (exp (Y[k]) - 1);
   }
}

void Loop23(int n)
{
   int j,k;
   double QA;

   for (j = 1; j < 6; j++) {
      for (k = 1; k < n; k++) {

	 QA = ZA[k][j+1] * ZR[k][j] + ZA[k][j-1] * ZB[k][j] +
	      ZA[k+1][j] * ZU[k][j] + ZA[k-1][j] * ZV[k][j] + ZZ[k][j];

	 ZA[k][j] += 0.175 * (QA - ZA[k][j]);
      }
   }
}

void Loop24(int n)
{
   int k;

   max24 = 0;
   for (k = 1; k < n; k++) {
      if (X[k] < X[max24]) max24 = k;
   }
   max24++;
}

int sgn(double a)
{
   if (a > 0) return 1;
   else if (a == 0) return 0;
   else return -1; 
}

double sq(double r)
{
   return r * r;
}

int MOD2N(int i,int j)
{
   if (i < 0) return i % j + (j / 2) + abs(j/2);
   else return i % j + (j / 2) - abs(j/2);
}



void initial(int n)
{
      int i,j,k,joke;
      double ss,one9th;

      vector ();
      ss = 1.0;
      one9th = 1.0 / 9.0;
      iter[0] = 990;
      iter[1] = 101;
      iter[2] = 1001;
      iter[3] = 35;
      iter[4] = 101;
      iter[5] = 64;
      iter[6] = 995;
      iter[7] = 100;
      iter[8] = 101;
      iter[9] = 101;
      iter[10] = 128;
      iter[11] = 1000;
      iter[12] = 64;
      iter[13] = 1001;
      iter[14] = 101;
      iter[15] = 75;
      iter[16] = 101;
      iter[17] = 100;
      iter[18] = 101;
      iter[19] = 100;
      iter[20] = 10;
      iter[21] = 101;
      iter[22] = 100;
      iter[23] = 1001;

      for (i = 0; i < 96; i++) {
	 E[i] = 1;
	 F[i] = 1;
      }

      for (i = 0; i < 4; i++) {
	 for (j = 0; j < 512; j++) {
	    P[i][j] = ss;
	    ss = ss + 0.5;
	 }
      }

      for (i = 0; i < 1001; i++) {
	 VX[i] = 0.001;
	 XX[i] = 2.001;
	 GRD[i] = 3.0 + one9th;
      }

      for (i = 0; i < 1001; i++) {
	 joke = (i+1) * one9th;
	 if (joke < 1) joke = 1;
	 EX[i] = joke;
	 RH[joke-1] = joke;
	 DEX[joke-1] = joke;
      }

      if (n == 16) {
	 D[0] = 1.01980486428764;

	 for (i = 1; i < 300; i++)
	   D[i] = D[i-1] + (1.0e-4 / D[i-1]);

	 R = D[iter[16-1]-1];

	 for (i = 0; i < 2; i++) {
	    m = (iter[16-1] + iter[16-1]) * i;
	    for (j = 0; j < 2; j++) {
	       for (k = 0; k < iter[16-1]; k++) {
		  S = k+1;
		  PLAN[m] = R * ((S + 1.0) / S);
		  ZONE[m++] = k + k + 2;
	       }
	    }
	 }

	 S = D[iter[16-1] - 2];
	 T = D[iter[16-1] - 3];
	 ZONE[iter[16-1]+iter[16-1]] = iter[16-1];
      }
}

void vector(void)
{
   int	  i,j,k,l;
   double bias,buzz,fizz,fuzz,scale;
   double *A[29];
   int	  AC[29];
   int	  AC1[23], AC2[23];

   bias = 0.0;
   scale = 0.01;
   fuzz = 1.2345E-3;
   buzz = 1.0 + fuzz;
   fizz = 1.1 * fuzz;

   A[0] = &A11; A[1] = &A12; A[2] = &A13;
   A[3] = &A21; A[4] = &A22; A[5] = &A23;
   A[6] = &A31; A[7] = &A32; A[8] = &A33;
   A[9] = &CO; A[10] = &DK;
   A[11] = &DM22; A[12] = &DM23; A[13] = &DM24; A[14] = &DM25;
   A[15] = &DM26; A[16] = &DM27; A[17] = &DM28;
   A[18] = &FLX; A[19] = &Q; A[20] = &R;  A[21] = &S;
   A[22] = &SIG; A[23] = &STB5; A[24] = &T;

   for (i = 0; i < 25; i++) {
      buzz = ((1.0 - fuzz) * buzz) + fuzz;
      fuzz = -fuzz;
      *(A[i]) = ((buzz - fizz) - bias) * scale;
   }

   A[0] = B5; A[1] = D; A[2] = DEX; A[3] = DEX1; A[4] = EX; 
   A[5] = EX1; A[6] = G; A[7] = GRD; A[8] = PLAN; A[9] = RH;
   A[10] = RX; A[11] = SA; A[12] = SB; A[13] = VE3; A[14] = VLIN;
   A[15] = VLR; A[16] = VSP; A[17] = VSTP; A[18] = VX; 
   A[19] = VXND; A[20] = VXNE; A[21] = XI; A[22] = XX; A[23] = U;
   A[24] = V; A[25] = W; A[26] = X; A[27] = Y; A[28] = Z;

   AC[0] = 101; AC[1] = 300; AC[2] = 1001; AC[3] = 1001; AC[4] = 1001; 
   AC[5] = 1001; AC[6] = 1001; AC[7] = 1001; AC[8] = 300; AC[9] = 1001;
   AC[10] = 1001; AC[11] = 101;	 AC[12] = 101; AC[13] = 101; AC[14] = 101;
   AC[15] = 101; AC[16] = 101; AC[17] = 101; AC[18] = 1001; 
   AC[19] = 101; AC[20] = 101; AC[21] = 1001; AC[22] = 1001; AC[23] = 1001;
   AC[24] = 1001; AC[25] = 1001; AC[26] = 1001; AC[27] = 1001; AC[28] = 1001;

   for (i = 0; i < 29; i++) {
      for (j = 0; j < AC[i]; j++) {
	 buzz = ((1.0 - fuzz) * buzz) + fuzz;
	 fuzz = -fuzz;
	 A[i][j] = ((buzz - fizz) - bias) * scale;
      }
   }

   A[0] = (double *)B; A[1] = (double *)C; A[2] = (double *)H; A[3] = (double *)P; 
   A[4] = (double *)CX; A[5] = (double *)PX;

   A[6] = (double *)U1; A[7] = (double *)U2; A[8] = (double *)U3;

   A[9] = (double *)VF; A[10] = (double *)VG; A[11] = (double *)VH; A[12] = (double *)VS; A[13] = (double *)VY; A[14] = (double *)ZA; 
   A[15] = (double *)ZB; A[16] = (double *)ZM; A[17] = (double *)ZP; A[18] = (double *)ZQ; A[19] = (double *)ZR; A[20] = (double *)ZU; 
   A[21] = (double *)ZV; A[22] = (double *)ZZ;


   AC2[0] = 0; AC2[1] = 0; AC2[2] = 0; AC2[3] = 0;
   AC2[4] = 0; AC2[5] = 0;

   AC1[0] = 64; AC1[1] = 64; AC1[2] = 64; AC1[3] = 4;
   AC1[4] = 25; AC1[5] = 25;

   AC[0] = 64; AC[1] = 64; AC[2] = 64; AC[3] = 512;
   AC[4] = 101; AC[5] = 101;


   AC2[6] = 5; AC2[7] = 5; AC2[8] = 5;
   AC1[6] = 101; AC1[7] = 101; AC1[8] = 101;
   AC[6] = 2; AC[7] = 2; AC[8] = 2;


   AC2[9] = 0; AC2[10] = 0; AC2[11] = 0; AC2[12] = 0; AC2[13] = 0;
   AC2[14] = 0; AC2[15] = 0; AC2[16] = 0; AC2[17] = 0; AC2[18] = 0;
   AC2[19] = 0; AC2[20] = 0; AC2[21] = 0; AC2[22] = 0;

   AC1[9] = 101; AC1[10] = 101; AC1[11] = 101; AC1[12] = 101; AC1[13] = 101;
   AC1[14] = 101; AC1[15] = 101; AC1[16] = 101; AC1[17] = 101; AC1[18] = 101;
   AC1[19] = 101; AC1[20] = 101; AC1[21] = 101; AC1[22] = 101;

   AC[9] = 7; AC[10] = 7; AC[11] = 7; AC[12] = 7; AC[13] = 25;
   AC[14] = 7; AC[15] = 7; AC[16] = 7; AC[17] = 7; AC[18] = 7;
   AC[19] = 7; AC[20] = 7; AC[21] = 7; AC[22] = 7;

   for (i = 0; i < 23; i++) {
      for (l = 0; l < AC[i]; l++) {
	 for (k = 0; k < AC1[i]; k++) {
	    if (!AC2[i]) {
	       buzz = ((1.0 - fuzz) * buzz) + fuzz;
	       fuzz = -fuzz;
	       *(A[i] + k*AC[i] + l) = ((buzz - fizz) - bias) * scale;
	    }
	    else for (j = 0; j < AC2[i]; j++) {
	       buzz = ((1.0 - fuzz) * buzz) + fuzz;
	       fuzz = -fuzz;
	       *(A[i] + j*AC1[i]*AC[i] + k*AC[i] + l) = 
					((buzz - fizz) - bias) * scale;
	    }
	 }
      }
   }
}

void wrinput(int loop)
{
   FILE *fp;
   /* int (*wr_func)(); */
   char fname[8];

   sprintf (fname, "l%d.in", loop);
   fp = fopen (fname, "w");

   if (!fp) open_error (fname);

   fprintf (fp, "Loop%d(%4d,\n", loop, iter[loop-1]);

/*
   wr_func = wrin[loop-1];
   wr_func (fp);
*/
   new_wrin_func (loop-1, fp); /* replace above indirect call */
   
   fclose (fp);
}

void wr3wideflt(FILE *fp, int cnt, double array[])
{
   int i;

   for (i = 0; i < cnt; i++) {
      fprintf (fp, "%21.14e", array[i]);
      if ( i % 3 == 2 ) fprintf (fp, "\n");
      else fprintf (fp, "  ");
   }
}

void wrinput1(FILE *fp)
{
   fprintf (fp, "%21.14e, %21.14e, %21.14e, \n", Q,R,T);
   fprintf (fp, "[1:\n");

   wr3wideflt (fp, 1001, Y);
   fprintf (fp, "\n], [1:\n");
   wr3wideflt (fp, 1001, Z);
   fprintf (fp, "\n]);\n");
}

void wrinput2(FILE *fp)
{
   fprintf (fp, "[1:\n");
   wr3wideflt (fp, 1001, V);
   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 1001, X);
   fprintf (fp, "]\n");
}

void wrinput3(FILE *fp)
{
   fprintf (fp, "[1:\n");
   wr3wideflt (fp, 1001, X);
   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 1001, Z);
   fprintf (fp, "]\n");
}

void wrinput4(FILE *fp)
{
   fprintf (fp, "[1:\n");
   wr3wideflt (fp, 1001, X);
   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 1001, Y);
   fprintf (fp, "]\n");
}

void wrinput5(FILE *fp)
{
   fprintf (fp, "[1:\n");
   wr3wideflt (fp, 1001, X);
   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 1001, Y);
   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 1001, Z);
   fprintf (fp, "]\n");
}

void wrinput6(FILE *fp)
{
   int	i;

   fprintf (fp, "[1:\n");
   for (i = 0; i < 64; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 64, B[i]);
      fprintf (fp, "\n]\n");
   }
   fprintf (fp, "\n], [1:\n");

   wr3wideflt (fp, 1001, W);
   fprintf (fp, "]\n");
}

void wrinput7(FILE *fp)
{
   fprintf (fp, "%21.14e, %21.14e\n", R,T);

   fprintf (fp, "[1:\n");
   wr3wideflt (fp, 1001, U);
   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 1001, Y);
   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 1001, Z);
   fprintf (fp, "]\n");
}

void wrinput8(FILE *fp)
{
   int	i,j;

   fprintf (fp, "%21.14e, %21.14e, %21.14e, \n", A11,A12,A13);
   fprintf (fp, "%21.14e, %21.14e, %21.14e, \n", A21,A22,A23);
   fprintf (fp, "%21.14e, %21.14e, %21.14e, \n", A31,A32,A33);
   fprintf (fp, "%21.14e,\n", SIG);
   fprintf (fp, "[1:\n");

   for (i = 0; i < 5; i++) {
      fprintf (fp, "[1:\n");
      for (j = 0; j < 101; j++) {
	 fprintf (fp, "[1: %21.14e  %21.14e  ]\n", U1[i][j][0], U1[i][j][1]);
      }
      fprintf (fp, "]\n");
   }

   for (i = 0; i < 5; i++) {
      fprintf (fp, "[1:\n");
      for (j = 0; j < 101; j++) {
	 fprintf (fp, "[1: %21.14e  %21.14e  ]\n", U2[i][j][0], U2[i][j][1]);
      }
      fprintf (fp, "]\n");
   }

   for (i = 0; i < 5; i++) {
      fprintf (fp, "[1:\n");
      for (j = 0; j < 101; j++) {
	 fprintf (fp, "[1: %21.14e  %21.14e  ]\n", U3[i][j][0], U3[i][j][1]);
      }
      fprintf (fp, "]\n");
   }

   fprintf (fp, "]);\n");
}

void wrinput9(FILE *fp)
{
   int	i;

   fprintf (fp, "%21.14e\n", CO);
   fprintf (fp, "%21.14e, %21.14e\n", DM22, DM23);
   fprintf (fp, "%21.14e, %21.14e\n", DM24, DM25);
   fprintf (fp, "%21.14e, %21.14e, %21.14e\n", DM26, DM27, DM28);
   fprintf (fp, "[1:\n");

   for (i = 0; i < 25; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 101, PX[i]);
   }

   fprintf (fp, "]);\n");
}

void wrinput10(FILE *fp)
{
   int	i;

   fprintf (fp, "[1:\n");

   for (i = 0; i < 25; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 101, CX[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");

   for (i = 0; i < 25; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 101, PX[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "]);\n");
}

void wrinput11(FILE *fp)
{
   fprintf (fp, "[1:\n");
   wr3wideflt (fp, 1001, Y);
   fprintf (fp, "]);\n");
}

void wrinput12(FILE *fp)
{
   fprintf (fp, "[1:\n");
   wr3wideflt (fp, 1001, Y);
   fprintf (fp, "]);\n");
}

void wrinput13(FILE *fp)
{
   int	i;

   fprintf (fp, "[1:\n");

   for (i = 0; i < 96; i++) {
      fprintf (fp, "%5d	 ", E[i]);
      if ( i % 10 == 9 ) fprintf (fp, "\n");
   }
   fprintf (fp, "], [1:\n");

   for (i = 0; i < 96; i++) {
      fprintf (fp, "%5d	 ", F[i]);
      if ( i % 10 == 9 ) fprintf (fp, "\n");
   }
   fprintf (fp, "], [1::\n");

   for (i = 0; i < 64; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 64, B[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 64; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 64, C[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 64; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 64, H[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 4; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 512, P[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 1001, Y);

   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 1001, Z);

   fprintf (fp, "]);\n");
}

void wrinput14(FILE *fp)
{
   fprintf (fp, "%21.14e,\n", FLX);
   fprintf (fp, "[1:\n");

   wr3wideflt (fp, 1001, DEX);
   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 1001, EX);
   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 1001, GRD);
   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 1001, RH);
   fprintf (fp, "]);\n");
}

void wrinput15(FILE *fp)
{
   int	i;

   fprintf (fp, "[1:\n");

   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, VF[i]);
      fprintf (fp, "\n]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, VG[i]);
      fprintf (fp, "\n]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, VH[i]);
      fprintf (fp, "\n]\n");
   }

   fprintf (fp, "]);\n");
}

void wrinput16(FILE *fp)
{
   int	i;

   fprintf (fp, "%21.14e, %21.14e, %21.14e, \n", R,S,T);

   fprintf (fp, "[1:\n");
   wr3wideflt (fp, 300, D);
   fprintf (fp, "], [1:\n");

   wr3wideflt (fp, 300, PLAN);
   fprintf (fp, "], [1:\n");

   for (i = 0; i < 300; i += 3)
      fprintf (fp, "%5d	 %5d  %5d\n", ZONE[i], ZONE[i+1], ZONE[i+2]);

   fprintf (fp, "    2 ]);\n");
}

void wrinput17(FILE *fp)
{
   fprintf (fp, "[1:\n");
   wr3wideflt (fp, 101, VLIN);
   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 101, VLR);
   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 101, VSP);
   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 101, VSTP);
   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 101, VXNE);
   fprintf (fp, "]);\n");
}

void wrinput18(FILE *fp)
{
   int	i;

   fprintf (fp, "%21.14e, %21.14e\n", S,T);

   fprintf (fp, "[1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, ZA[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, ZB[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, ZM[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, ZP[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, ZQ[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, ZR[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, ZU[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, ZV[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, ZZ[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "]);\n");
}

void wrinput19(FILE *fp)
{
   fprintf (fp, "%21.14e,\n", STB5);
   fprintf (fp, "[1:\n");
   wr3wideflt (fp, 101, SA);
   fprintf (fp, "], [1:\n");
   wr3wideflt (fp, 101, SB);
   fprintf (fp, "]);\n");
}

void wrinput20(FILE *fp)
{
   fprintf (fp, "%21.14e, %21.14e,\n", DK,S);
   fprintf (fp, "%21.14e, %21.14e,\n", T,XX[0]);

   fprintf (fp, "[1:\n");
   wr3wideflt (fp, 1001, G);

   fprintf (fp, "] [1:\n");
   wr3wideflt (fp, 1001, U);

   fprintf (fp, "] [1:\n");
   wr3wideflt (fp, 1001, V);

   fprintf (fp, "] [1:\n");
   wr3wideflt (fp, 1001, VX);

   fprintf (fp, "] [1:\n");
   wr3wideflt (fp, 1001, W);

   fprintf (fp, "] [1:\n");
   wr3wideflt (fp, 1001, Y);

   fprintf (fp, "] [1:\n");
   wr3wideflt (fp, 1001, Z);

   fprintf (fp, "]);\n");
}

void wrinput21(FILE *fp)
{
   int	i;

   fprintf (fp, "[1:\n");
   for (i = 0; i < 25; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 101, CX[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 25; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 101, PX[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 25, VY[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "]);\n");
}

void wrinput22(FILE *fp)
{
   fprintf (fp, "[1:\n");
   wr3wideflt (fp, 1001, U);

   fprintf (fp, "] [1:\n");
   wr3wideflt (fp, 1001, V);

   fprintf (fp, "] [1:\n");
   wr3wideflt (fp, 1001, X);

   fprintf (fp, "]);\n");
}

void wrinput23(FILE *fp)
{
   int	i;

   fprintf (fp, "[1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, ZA[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, ZB[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, ZR[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, ZU[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, ZV[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "], [1:\n");
   for (i = 0; i < 101; i++) {
      fprintf (fp, "[1:\n");
      wr3wideflt (fp, 7, ZZ[i]);
      fprintf (fp, "]\n");
   }

   fprintf (fp, "]);\n");
}

void wrinput24(FILE *fp)
{
   fprintf (fp, "[1:\n");
   wr3wideflt (fp, 1001, X);
   fprintf (fp, "]);\n");
}

void wroutput(int loop)
{
   FILE *fp;
   /* int (*wr_func)(); */
   char fname[8];

   sprintf (fname, "l%d.out", loop);
   fp = fopen (fname, "w");

   if (!fp) open_error (fname);

/* 
   wr_func = wrout[loop-1];
   wr_func (fp);
*/
   new_wrout_func(loop-1, fp); /* replace above indirect call */
   
   fclose (fp);
}

void wroutput1(FILE *fp)
{
   wr3wideflt (fp, iter[1-1], X);
}

void wroutput2(FILE *fp)
{
   wr3wideflt (fp, 198, X);
}

void wroutput3(FILE *fp)
{
   fprintf (fp, "%21.14e\n", Q);
}

void wroutput4(FILE *fp)
{
   wr3wideflt (fp, 1001, X);
}

void wroutput5(FILE *fp)
{
   wr3wideflt (fp, iter[5-1], X);
}

void wroutput6(FILE *fp)
{
   wr3wideflt (fp, iter[6-1], W);
}

void wroutput7(FILE *fp)
{
   wr3wideflt (fp, iter[7-1], X);
}

void wroutput8(FILE *fp)
{
   int i,j;

   for (i = 1; i < 3; i++)
      for (j = 1; j < iter[8-1]; j++)
	 fprintf (fp, "%21.14e	%21.14e\n", U1[i][j][0], U1[i][j][1]);

   for (i = 1; i < 3; i++)
      for (j = 1; j < iter[8-1]; j++)
	 fprintf (fp, "%21.14e	%21.14e\n", U2[i][j][0], U2[i][j][1]);

   for (i = 1; i < 3; i++)
      for (j = 1; j < iter[8-1]; j++)
	 fprintf (fp, "%21.14e	%21.14e\n", U3[i][j][0], U3[i][j][1]);
}

void wroutput9(FILE *fp)
{
   int i;

   for (i = 0; i < 25; i++) {
      wr3wideflt (fp, iter[9-1], PX[i]);
      fprintf (fp, "\n");
   }
}

void wroutput10(FILE *fp)
{
   int i;

   for (i = 4; i < 14; i++) {
      wr3wideflt (fp, iter[10-1], PX[i]);
      fprintf (fp, "\n");
   }
}

void wroutput11(FILE *fp)
{
   wr3wideflt (fp, iter[11-1], X);
}

void wroutput12(FILE *fp)
{
   wr3wideflt (fp, iter[12-1], X);
}

void wroutput13(FILE *fp)
{
   int i;

   for (i = 0; i < 64; i++) {
      wr3wideflt (fp, 64, H[i]);
      fprintf (fp, "\n");
   }

   for (i = 0; i < 4; i++) {
      wr3wideflt (fp, 512, P[i]);
      fprintf (fp, "\n");
   }
}

void wroutput14(FILE *fp)
{
   int i;

   wr3wideflt (fp, iter[14-1], DEX1);
   fprintf (fp, "\n");

   wr3wideflt (fp, iter[14-1], EX1);
   fprintf (fp, "\n");

   for (i = 0; i < iter[14-1]; i++) {
      fprintf (fp, "%5d	 ", IR[i]);
      if ( i % 10 == 9 ) fprintf (fp, "\n");
   }
   fprintf (fp, "\n");

   for (i = 0; i < iter[14-1]; i++) {
      fprintf (fp, "%5d	 ", IX[i]);
      if ( i % 10 == 9 ) fprintf (fp, "\n");
   }
   fprintf (fp, "\n");

   wr3wideflt (fp, iter[14-1], RX);
   fprintf (fp, "\n");

   wr3wideflt (fp, iter[14-1], VX);
   fprintf (fp, "\n");

   wr3wideflt (fp, iter[14-1], XI);
   fprintf (fp, "\n");

   wr3wideflt (fp, iter[14-1], XX);
   fprintf (fp, "\n");

   wr3wideflt (fp, 1001, RH);
   fprintf (fp, "\n");
}

void wroutput15(FILE *fp)
{
   int i;

   for (i = 1; i < iter[15-1]; i++) {
      wr3wideflt (fp, 5, &VS[i][1]);
      fprintf (fp, "\n");
   }

   for (i = 1; i < iter[15-1]-1; i++) {
      wr3wideflt (fp, 6, &VY[i][1]);
   }
}

void wroutput16(FILE *fp)
{
   fprintf (fp, "%5d  %5d\n", m, j4+2);
}

void wroutput17(FILE *fp)
{
   int i, mod;

   mod = iter[17-1] % 3;

   for (i = iter[17-1]-1; i > 0; i--) {
      fprintf (fp, "%21.14e", VE3[i]);
      if ( i % 3 == mod ) fprintf (fp, "\n");
      else fprintf (fp, "  ");
   }
   fprintf (fp, "\n");

   for (i = iter[17-1]-1; i > 0; i--) {
      fprintf (fp, "%21.14e", VXND[i]);
      if ( i % 3 == mod ) fprintf (fp, "\n");
      else fprintf (fp, "  ");
   }
   fprintf (fp, "\n");

   for (i = iter[17-1]-1; i > 0; i--) {
      fprintf (fp, "%21.14e", VXNE[i]);
      if ( i % 3 == mod ) fprintf (fp, "\n");
      else fprintf (fp, "  ");
   }
   fprintf (fp, "\n");
}

void wroutput18(FILE *fp)
{
   int i;

   for (i = 0; i < 101; i++) {
      wr3wideflt (fp, 7, ZA[i]);
      fprintf (fp, "\n");
   }

   for (i = 0; i < 101; i++) {
      wr3wideflt (fp, 7, ZB[i]);
      fprintf (fp, "\n");
   }

   for (i = 1; i < iter[18-1]; i++) {
      wr3wideflt (fp, 5, &ZU[i][1]);
      fprintf (fp, "\n");
   }

   for (i = 1; i < iter[18-1]; i++) {
      wr3wideflt (fp, 5, &ZV[i][1]);
      fprintf (fp, "\n");
   }

   for (i = 1; i < iter[18-1]; i++) {
      wr3wideflt (fp, 5, &ZR[i][1]);
      fprintf (fp, "\n");
   }

   for (i = 1; i < iter[18-1]; i++) {
      wr3wideflt (fp, 5, &ZZ[i][1]);
      fprintf (fp, "\n");
   }
}

void wroutput19(FILE *fp)
{
   wr3wideflt (fp, iter[19-1], B5);
}

void wroutput20(FILE *fp)
{
   wr3wideflt (fp, iter[20-1], X);
   fprintf (fp, "\n");

   wr3wideflt (fp, iter[20-1], &XX[1]);
   fprintf (fp, "\n");
}

void wroutput21(FILE *fp)
{
   int i;

   for (i = 0; i < 15; i++) {
      wr3wideflt (fp, iter[21-1], PX[i]);
      fprintf (fp, "\n");
   }
}

void wroutput22(FILE *fp)
{
   wr3wideflt (fp, iter[22-1], W);
   fprintf (fp, "\n");

   wr3wideflt (fp, iter[22-1], Y);
   fprintf (fp, "\n");
}

void wroutput23(FILE *fp)
{
   int i;

   for (i = 0; i < 101; i++) {
      wr3wideflt (fp, 7, ZA[i]);
      fprintf (fp, "\n");
   }
}

void wroutput24(FILE *fp)
{
      fprintf (fp, "%5d", max24);
}

void open_error(char *fname)
{
   printf ("Could not open file %s\n", fname);
   exit (1);
}

/* The following procedures are added to eliminate function pointers */

void new_wrin_func(int loop, FILE *fp)
{
  switch (loop)  
    {
    case  0:
      wrinput1 (fp); break; 
    case  1:
      wrinput2 (fp); break; 
    case  2:
      wrinput3 (fp); break; 
    case  3:
      wrinput4 (fp); break;     
    case  4:
      wrinput5 (fp); break;       
    case  5:
      wrinput6 (fp); break; 
    case  6:
      wrinput7 (fp); break; 
    case  7:
      wrinput8 (fp); break; 
    case  8:
      wrinput9 (fp); break; 
    case  9:
      wrinput10 (fp); break; 
    case  10:
      wrinput11 (fp); break; 
    case  11:
      wrinput12 (fp); break; 
    case  12:
      wrinput13 (fp); break; 
    case  13:
      wrinput14 (fp); break; 
    case  14:
      wrinput15 (fp); break; 
    case  15:
      wrinput16 (fp); break; 
    case  16:
      wrinput17 (fp); break; 
    case  17:
      wrinput18 (fp); break; 
    case  18:
      wrinput19 (fp); break; 
    case  19:
      wrinput20 (fp); break; 
    case  20:
      wrinput21 (fp); break; 
    case  21:
      wrinput22 (fp); break; 
    case  22:
      wrinput23 (fp); break; 
    case  23:
      wrinput24 (fp); break; 
    }
}

void new_loop_func(int loop, int n)
{
  switch (loop)  
    {
    case  0:
      Loop1 (n); break; 
    case  1:
      Loop2 (n); break; 
    case  2:
      Loop3 (n); break; 
    case  3:
      Loop4 (n); break;     
    case  4:
      Loop5 (n); break;       
    case  5:
      Loop6 (n); break; 
    case  6:
      Loop7 (n); break; 
    case  7:
      Loop8 (n); break; 
    case  8:
      Loop9 (n); break; 
    case  9:
      Loop10 (n); break; 
    case  10:
      Loop11 (n); break; 
    case  11:
      Loop12 (n); break; 
    case  12:
      Loop13 (n); break; 
    case  13:
      Loop14 (n); break; 
    case  14:
      Loop15 (n); break; 
    case  15:
      Loop16 (n); break; 
    case  16:
      Loop17 (n); break; 
    case  17:
      Loop18 (n); break; 
    case  18:
      Loop19 (n); break; 
    case  19:
      Loop20 (n); break; 
    case  20:
      Loop21 (n); break; 
    case  21:
      Loop22 (n); break; 
    case  22:
      Loop23 (n); break; 
    case  23:
      Loop24 (n); break; 
    }
}


void new_wrout_func(int loop, FILE *fp)
{
  switch (loop)  
    {
    case  0:
      wroutput1 (fp); break; 
    case  1:
      wroutput2 (fp); break; 
    case  2:
      wroutput3 (fp); break; 
    case  3:
      wroutput4 (fp); break;     
    case  4:
      wroutput5 (fp); break;       
    case  5:
      wroutput6 (fp); break; 
    case  6:
      wroutput7 (fp); break; 
    case  7:
      wroutput8 (fp); break; 
    case  8:
      wroutput9 (fp); break; 
    case  9:
      wroutput10 (fp); break; 
    case  10:
      wroutput11 (fp); break; 
    case  11:
      wroutput12 (fp); break; 
    case  12:
      wroutput13 (fp); break; 
    case  13:
      wroutput14 (fp); break; 
    case  14:
      wroutput15 (fp); break; 
    case  15:
      wroutput16 (fp); break; 
    case  16:
      wroutput17 (fp); break; 
    case  17:
      wroutput18 (fp); break; 
    case  18:
      wroutput19 (fp); break; 
    case  19:
      wroutput20 (fp); break; 
    case  20:
      wroutput21 (fp); break; 
    case  21:
      wroutput22 (fp); break; 
    case  22:
      wroutput23 (fp); break; 
    case  23:
      wroutput24 (fp); break; 
    }
}
