/****************************************************************************/
/*                                                                          */
/*                  Usefull fonctions and basic definitions                 */
/*                                                                          */
/****************************************************************************/

#include <stdio.h>
#include <malloc.h>
#ifndef lint
#define Max_pts 1200
#define Max_trn 2500
#define Max_tree 1000
#define Max_pile 1000
#else
#define Max_pts 4
#define Max_trn 8
#define Max_tree 3
#define Max_pile 3
#endif

#define SOURCE_NAME "file.test"
#define DMNS_NAME "domain.test"
#define NODE_NAME "node.test"
#define RRDR_NAME "reorder.test"

typedef struct
	  {
	    int PTS,TRN;
	    int nb_mat[Max_pts], *point[Max_pts], *triangle[Max_pts];
	    int ptx[Max_trn], pty[Max_trn];
	    int p[3][Max_trn];
	  } 
	triangulation;

typedef struct
          {
            int total;
            int value[Max_tree], mode[Max_tree];
            int ref[Max_tree], owner[Max_tree];
            int x[Max_tree], y[Max_tree];
          }
        tree_structure;

typedef struct
          {
            int V[Max_pts];
            int T[Max_trn];
          }
        Elimination_State;

typedef struct
          {
            int complex;
            int *next,*nextnode;
            int *domain;
            int size;
            int *bound;
            int **front1;
            int **front2;
          }
        Node;

typedef struct
          {
            int size_a,    size_b;
            int *front1_a, *front1_b;
            int *front2_a, *front2_b;
            int chef_a,    chef_b;
            int newchef_a, newchef_b;
            int node_a,    node_b;
            int begin, end;
          }
        Domain;








