# 1 "inst.c" 
























# 1 "/usr/include/stdio.h" 1





extern	struct	_iobuf {
	int	_cnt;
	unsigned char *_ptr;
	unsigned char *_base;
	int	_bufsiz;
	short	_flag;
	char	_file;		
} _iob[];



















# 36 "/usr/include/stdio.h" 

















extern struct _iobuf	*fopen();
extern struct _iobuf	*fdopen();
extern struct _iobuf	*freopen();
extern struct _iobuf	*popen();
extern struct _iobuf	*tmpfile();
extern long	ftell();
extern char	*fgets();
extern char	*gets();
extern char	*sprintf();
extern char	*ctermid();
extern char	*cuserid();
extern char	*tempnam();
extern char	*tmpnam();






# 26 "inst.c" 2
# 1 "/usr/include/string.h" 1





# 1 "/usr/include/sys/stdtypes.h" 1













typedef	int		sigset_t;	

typedef	unsigned int	speed_t;	
typedef	unsigned long	tcflag_t;	
typedef	unsigned char	cc_t;		
typedef	int		pid_t;		

typedef	unsigned short	mode_t;		
typedef	short		nlink_t;	

typedef	long		clock_t;	
typedef	long		time_t;		

typedef	int		size_t;		
typedef int		ptrdiff_t;	

typedef	unsigned short	wchar_t;	


# 7 "/usr/include/string.h" 2

# 10 "/usr/include/string.h" 


extern char *	strcat();
extern char *	strchr();
extern int	strcmp();
extern char *	strcpy();
extern size_t	strcspn();

extern char *	strdup();

extern size_t	strlen();
extern char *	strncat();
extern int	strncmp();
extern char *	strncpy();
extern char *	strpbrk();
extern char *	strrchr();
extern size_t	strspn();
extern char *	strstr();
extern char *	strtok();


# 27 "inst.c" 2

# 1 "./spim.h" 1
























# 27 "./spim.h" 


























# 57 "./spim.h" 

# 1 "/usr/include/memory.h" 1





extern char
	*memccpy(),
	*memchr(),
	*memcpy(),
	*memset();
extern int memcmp();


# 59 "./spim.h" 2



# 66 "./spim.h" 

double atof ();
int atoi ();
int free ();
char *malloc ();
int strcmp ();
char *strcpy ();
char *strncpy ();







typedef unsigned long mem_addr;














































































































typedef struct strint
{
  char *name;
  int value1;
  int value2;
} inst_info;

# 201 "./spim.h" 

typedef int port;






# 223 "./spim.h" 

int console_input_available ();
void control_c_seen ();
void error ();
void fatal_error ();
char get_console_char ();
void put_console_char ();
void read_input ();
int run_error ();
void write_output ();





extern int bare_machine;	
extern int quiet;		
extern int source_file;		


extern port message_out, console_out, console_in;

extern int mapped_io;		

# 250 "./spim.h" 


extern mem_addr program_starting_address;

extern long initial_text_size;

extern long initial_data_size;

extern long initial_data_limit;

extern long initial_stack_size;

extern long initial_stack_limit;

extern long initial_k_text_size;

extern long initial_k_data_size;

extern long initial_k_data_limit;
# 29 "inst.c" 2
# 1 "./spim-utils.h" 1



























# 45 "./spim-utils.h" 

void add_breakpoint ();
void end_of_assembly_file ();
void delete_breakpoint ();
void fatal_error ();
void initialize_registers ();
void initialize_run_stack ();
void initialize_world ();
void list_breakpoints ();
inst_info *map_int_to_inst_info ();
inst_info *map_string_to_inst_info ();
int read_assembly_file ();
int run_program ();
mem_addr starting_address ();
char *str_copy ();
void write_startup_message ();
char *xmalloc ();
char *zmalloc ();

# 30 "inst.c" 2
# 1 "./inst.h" 1





























typedef struct immexpr
{
  long offset;			
  struct lab *symbol;		
  short bits;			
  short pc_relative;		
} imm_expr;





typedef struct addrexpr
{
  unsigned char reg_no;		
  imm_expr *imm;		
} addr_expr;






typedef struct inst_s
{
  short opcode;

  union
    {
      
      struct
	{
	  unsigned char rs;
	  unsigned char rt;

	  union
	    {
	      short imm;

	      struct
		{
		  unsigned char rd;
		  unsigned char shamt;
		} r;
	    } r_i;
	} r_i;

      
      long target;
    } r_t;

  unsigned long encoding;
  imm_expr *expr;
  char *source_line;
} instruction;

























































































# 210 "./inst.h" 

imm_expr *addr_expr_imm ();
int addr_expr_reg ();
imm_expr *const_imm_expr ();
imm_expr *copy_imm_expr ();
instruction *copy_inst ();
mem_addr current_text_pc ();
long eval_imm_expr ();
void free_inst ();
void i_type_inst ();
void i_type_inst_free ();
void increment_text_pc ();
imm_expr *incr_expr_offset ();
instruction *inst_decode ();
long inst_encode ();
int inst_is_breakpoint ();
void j_type_inst ();
void k_text_begins_at_point ();
void k_text_begins_at_point ();
imm_expr *lower_bits_of_expr ();
addr_expr *make_addr_expr ();
imm_expr *make_imm_expr ();
int opcode_is_branch ();
int opcode_is_jump ();
int opcode_is_load_store ();
void print_inst ();
int print_inst_internal ();
void r_cond_type_inst ();
void r_sh_type_inst ();
void r_type_inst ();
instruction *set_breakpoint ();
void store_instruction ();
void text_begins_at_point ();
imm_expr *upper_bits_of_expr ();
void user_kernel_text_segment ();
int zero_imm ();

# 31 "inst.c" 2
# 1 "./mem.h" 1































typedef long mem_word;




extern instruction **text_seg;

extern int text_modified;	



extern mem_addr text_top;









extern mem_word *data_seg;

extern int data_modified;	

extern short *data_seg_h;	












extern char *data_seg_b;	



extern mem_addr data_top;

extern mem_addr gp_midpoint;	




extern mem_word *stack_seg;

extern short *stack_seg_h;	

extern char *stack_seg_b;	

extern mem_addr stack_bot;








extern instruction **k_text_seg;



extern mem_addr k_text_top;




extern mem_word *k_data_seg;

extern short *k_data_seg_h;

char *k_data_seg_b;



extern mem_addr k_data_top;

















































































































































# 272 "./mem.h" 

mem_word bad_mem_read ();
void bad_mem_write ();
instruction *bad_text_read ();
void bad_text_write ();
void check_memory_mapped_IO ();
void expand_data ();
void expand_k_data ();
void expand_stack ();
void make_memory ();
void print_mem ();

# 32 "inst.c" 2
# 1 "./reg.h" 1

























typedef long reg_word;
typedef unsigned long u_reg_word;




extern reg_word R[32];

extern reg_word HI, LO;
# 37 "./reg.h" 


extern mem_addr PC, nPC;



























extern double *FPR;		
extern float *FGR;		
extern int *FWR;		


extern int FP_reg_present;	
extern int FP_reg_poison;	
extern int FP_spec_load;	



































extern reg_word CpCond[4], CCR[4][32], CPR[4][32];





int exception_occurred;















# 33 "inst.c" 2
# 1 "./sym-tbl.h" 1

























typedef struct lab_use
{
  instruction *inst;		
  mem_addr addr;
  struct lab_use *next;
} label_use;




typedef struct lab
{
  char *name;			
  long addr;			
  unsigned global_flag : 1;	
  unsigned gp_flag : 1;		
  unsigned const_flag : 1;	
  struct lab *next;		
  struct lab *next_local;	
  label_use *uses;		
} label;			








# 68 "./sym-tbl.h" 

mem_addr find_symbol_address ();
void flush_local_labels ();
void initialize_symbol_table ();
label *label_is_defined ();
label *lookup_label ();
label *make_label_global ();
void print_symbols ();
label *record_label ();
void record_data_uses_symbol ();
void record_inst_uses_symbol ();
void resolve_a_label ();
void resolve_label_uses ();

# 34 "inst.c" 2
# 1 "./y.tab.h" 1


























































































































































































































































# 35 "inst.c" 2
# 1 "./parser.h" 1



























# 35 "./parser.h" 

void fix_current_label_address ();
int imm_op_to_op ();
void initialize_parser ();
int op_to_imm_op ();
void yyerror ();
int yyparse ();





extern int data_dir;		

extern int text_dir;		
# 36 "inst.c" 2
# 1 "./scanner.h" 1



























# 35 "./scanner.h" 

void initialize_scanner ();
void print_erroneous_line ();
void scanner_start_line ();
int register_name_to_number ();
char *source_line ();
int yylex ();









extern int only_id;

extern int yylval;		

extern int line_no;		

extern int y_str_length;	
# 37 "inst.c" 2
# 1 "./data.h" 1



























# 48 "./data.h" 

void align_data ();
mem_addr current_data_pc ();
void data_begins_at_point ();
void enable_data_alignment ();
void end_of_assembly_file ();
void extern_directive ();
void increment_data_pc ();
void k_data_begins_at_point ();
void lcomm_directive ();
void set_data_alignment ();
void set_data_pc ();
void set_text_pc ();
void store_byte ();
void store_double ();
void store_float ();
void store_half ();
void store_string ();
void store_word ();
void user_kernel_data_segment ();

# 38 "inst.c" 2




# 55 "inst.c" 

static int compare_pair_value ();
static void i_type_inst_f ();
static void i_type_inst_full_word ();
static void inst_cmp ();
static instruction * make_r_type_inst ();
static instruction *mk_i_inst ();
static instruction *mk_j_inst ();
static instruction *mk_r_inst ();
static int print_imm_expr ();
static void sort_name_table ();







static int in_kernel = 0;



static instruction *break_inst = 0;




static mem_addr next_text_pc;

static mem_addr next_k_text_pc;











# 99 "inst.c" 

void
text_begins_at_point (addr)
     mem_addr addr;

{
  next_text_pc = addr;
}


# 112 "inst.c" 

void
k_text_begins_at_point (addr)
     mem_addr addr;

{
  next_k_text_pc = addr;
}




# 127 "inst.c" 

void
set_text_pc (addr)
     mem_addr addr;

{
  if (in_kernel)
    next_k_text_pc = addr;
  else
    next_text_pc = addr;
}




# 145 "inst.c" 

mem_addr
current_text_pc ()

{
  return ((in_kernel ? next_k_text_pc : next_text_pc));
}




# 159 "inst.c" 

void
increment_text_pc (delta)
     int delta;

{
  {if (in_kernel) next_k_text_pc += delta; else next_text_pc += delta;};
}





# 175 "inst.c" 

void
user_kernel_text_segment (to_kernel)
     int to_kernel;

{
  in_kernel = to_kernel;
}




# 190 "inst.c" 

void
store_instruction (inst)
     instruction *inst;

{
  if (data_dir)
    {
      store_word (inst_encode (inst));
      free_inst (inst);
    }
  else if (text_dir)
    {
      exception_occurred = 0;
      {register mem_addr _addr_ = (mem_addr) ((in_kernel ? next_k_text_pc : next_text_pc)); text_modified = 1; if (_addr_ >= ((mem_addr) 0x400000) && _addr_ < text_top && !(_addr_ & 0x3)) text_seg [(_addr_ - ((mem_addr) 0x400000)) >> 2] =  inst; else if (_addr_ >= ((mem_addr) 0x80000000) && _addr_ < k_text_top && !(_addr_ & 0x3)) k_text_seg [(_addr_ - ((mem_addr) 0x80000000)) >> 2] =  inst; else bad_text_write (_addr_,  inst);};
      if (exception_occurred)
	error ("Invalid address (0x%08x) for instruction\n", (in_kernel ? next_k_text_pc : next_text_pc));
      else
	{if (in_kernel) next_k_text_pc += 4; else next_text_pc += 4;};
      if (inst != 0)
	{
	  (inst)->source_line = source_line ();
	  if ((inst)->encoding == 0)
	    (inst)->encoding = inst_encode (inst);
	}
    }
}



# 223 "inst.c" 

void
i_type_inst_free (opcode, rt, rs, expr)
     int opcode, rt, rs;
     imm_expr *expr;

{
  i_type_inst (opcode, rt, rs, expr);
  free (expr);
}








# 244 "inst.c" 

void
i_type_inst (opcode, rt, rs, expr)
     int opcode, rt, rs;
     imm_expr *expr;

{
  instruction *inst = (instruction *) zmalloc (sizeof (instruction));

  (inst)->opcode = opcode;
  (inst)->r_t.r_i.rs = rs;
  (inst)->r_t.r_i.rt = rt;
  (inst)->expr = copy_imm_expr (expr);
  if (expr->symbol == 0 || ((expr->symbol)->addr != 0))
    {
      
      long value = eval_imm_expr (expr);

      if (!bare_machine
	  && (value & 0xffff0000) != 0
	  && !((value & 0xffff0000) == 0xffff0000
	       && (opcode == 267
		   || opcode == 266
		   || opcode == 391
		   || opcode == 390)))
	{
	  free_inst (inst);
	  i_type_inst_full_word (opcode, rt, rs, expr, 1, value);
	  return;
	}
      else
	resolve_a_label (expr->symbol, inst);
    }
  else if (bare_machine || expr->bits != 0)
    

    record_inst_uses_symbol (inst, expr->symbol);
  else
    {
      


      free_inst (inst);

      i_type_inst_full_word (opcode, rt, rs, expr, 0, 0);
      return;
    }

  store_instruction (inst);
}





# 303 "inst.c" 

static void
i_type_inst_full_word (opcode, rt, rs, expr, value_known, value)
     int opcode, rt, rs;
     imm_expr *expr;
     int value_known;
     long value;

{
  if (opcode_is_load_store (opcode))
    {
      long offset;

      if (expr->symbol != 0
	  && expr->symbol->gp_flag && rs == 0
	  && (offset = expr->symbol->addr + expr->offset) >= -32*1024
	  && offset < 32*1024)
	i_type_inst_free (opcode, rt, 28, make_imm_expr (offset, 0, 0));
      else if (value_known)
	{
	  int low, high;

	  high = (value >> 16) & 0xffff;
	  low = 0xffff & value;

	  if (high &&
	      !(high == 0xffff && (low & 0x8000))) 
	    {
	      if (low & 0x8000)
		high += 1;		

	      i_type_inst_free (353, 1, 0, const_imm_expr (high));
	      if (rs != 0)	
		r_type_inst (268, 1, 1, rs);
	      i_type_inst_free (opcode, rt, 1, const_imm_expr (low));
	    }
	  else
	    i_type_inst_free (opcode, rt, rs, const_imm_expr (low));
	}
      else
	{
	  
	  
	  i_type_inst_free (353, 1, 0, upper_bits_of_expr (expr));
	  if (rs != 0)		
	    r_type_inst (268, 1, 1, rs);
	  i_type_inst_free (opcode, rt, 1, lower_bits_of_expr (expr));
	}
    }
  else if (opcode_is_branch (opcode))
    {
      
      i_type_inst_free (opcode, rt, rs, lower_bits_of_expr (expr));
    }
  else
    
    {
      long offset;

      if (expr->symbol != 0
	  && expr->symbol->gp_flag && rs == 0
	  && (offset = expr->symbol->addr + expr->offset) >= -32*1024
	  && offset < 32*1024)
	i_type_inst_free ((opcode == 353 ? 266 : opcode),
		       rt, 28, make_imm_expr (offset, 0, 0));
      else
	{
	  
	  if ((opcode == 382
	       || opcode == 267 || opcode == 266
	       || opcode == 353)
	      && rs == 0)
	    {
	      if (value_known && (value & 0xffff) == 0)
		i_type_inst_free (353, rt, 0, upper_bits_of_expr (expr));
	      else
		{
		  i_type_inst_free (353, 1, 0, upper_bits_of_expr (expr));
		  i_type_inst_free (382, rt, 1, lower_bits_of_expr(expr));
		}
	    }
	  else
	    {
	      i_type_inst_free (353, 1, 0, upper_bits_of_expr (expr));
	      i_type_inst_free (382, 1, 1, lower_bits_of_expr (expr));
	      r_type_inst (imm_op_to_op (opcode), rt, rs, 1);
	    }
	}
    }
}






# 402 "inst.c" 

void
j_type_inst (opcode, target)
     int opcode;
     imm_expr *target;

{
  instruction *inst = (instruction *) zmalloc (sizeof (instruction));

  (inst)->opcode = opcode;
  target->offset = 0;		
  target->pc_relative = 0;
  (inst)->expr = copy_imm_expr (target);
  if (target->symbol == 0 || ((target->symbol)->addr != 0))
    resolve_a_label (target->symbol, inst);
  else
    record_inst_uses_symbol (inst, target->symbol);
  store_instruction (inst);
}





# 429 "inst.c" 

static instruction *
make_r_type_inst (opcode, rd, rs, rt)
     int opcode, rd, rs, rt;

{
  instruction *inst = (instruction *) zmalloc (sizeof (instruction));

  (inst)->opcode = opcode;
  (inst)->r_t.r_i.rs = rs;
  (inst)->r_t.r_i.rt = rt;
  (inst)->r_t.r_i.r_i.r.rd = rd;
  (inst)->r_t.r_i.r_i.r.shamt = 0;
  return (inst);
}





# 452 "inst.c" 

void
r_type_inst (opcode, rd, rs, rt)
     int opcode, rd, rs, rt;

{
  store_instruction (make_r_type_inst (opcode, rd, rs, rt));
}





# 468 "inst.c" 

void
r_sh_type_inst (opcode, rd, rt, shamt)
     int opcode, rd, rt, shamt;

{
  instruction *inst = make_r_type_inst (opcode, rd, 0, rt);

  (inst)->r_t.r_i.r_i.r.shamt = shamt & 0x1f;
  store_instruction (inst);
}





# 487 "inst.c" 

void
r_cond_type_inst (opcode, rs, rt)
     int opcode, rs, rt;

{
  instruction *inst = make_r_type_inst (opcode, 0, rs, rt);

  switch (opcode)
    {
    case 309:
    case 310:
      {
	(inst)->r_t.r_i.r_i.imm = 0x2;
	break;
      }

    case 313:
    case 314:
      {
	(inst)->r_t.r_i.r_i.imm = 0x8 | 0x4 | 0x2;
	break;
      }

    case 315:
    case 316:
      {
	(inst)->r_t.r_i.r_i.imm = 0x8 | 0x4;
	break;
      }

    case 317:
    case 318:
      {
	(inst)->r_t.r_i.r_i.imm = 0x8 | 0x4 | 0x1;
	break;
      }

    case 319:
    case 320:
      {
	(inst)->r_t.r_i.r_i.imm = 0x8 | 0x1;
	break;
      }

    case 321:
    case 322:
      {
	(inst)->r_t.r_i.r_i.imm = 0x8 | 0x2 | 0x1;
	break;
      }

    case 323:
    case 324:
      {
	(inst)->r_t.r_i.r_i.imm = 0x8 | 0x4 | 0x2 | 0x1;
	break;
      }

    case 325:
    case 326:
      {
	(inst)->r_t.r_i.r_i.imm = 0x4;
	break;
      }

    case 327:
    case 328:
      {
	(inst)->r_t.r_i.r_i.imm = 0x4 | 0x2;
	break;
      }

    case 329:
    case 330:
      {
	(inst)->r_t.r_i.r_i.imm = 0x8 | 0x2;
	break;
      }

    case 331:
    case 332:
      {
	(inst)->r_t.r_i.r_i.imm = 0x8;
	break;
      }

    case 311:
    case 312:
      {
	(inst)->r_t.r_i.r_i.imm = 0;
	break;
      }

    case 333:
    case 334:
      {
	(inst)->r_t.r_i.r_i.imm = 0x2 | 0x1;
	break;
      }

    case 335:
    case 336:
      {
	(inst)->r_t.r_i.r_i.imm = 0x4 | 0x1;
	break;
      }

    case 337:
    case 338:
      {
	(inst)->r_t.r_i.r_i.imm = 0x4 | 0x2 | 0x1;
	break;
      }

    case 339:
    case 340:
      {
	(inst)->r_t.r_i.r_i.imm = 0x1;
	break;
      }
    }
  store_instruction (inst);
}




# 618 "inst.c" 

instruction *
copy_inst (inst)
instruction *inst;

{
  instruction *new_inst = (instruction *) xmalloc (sizeof (instruction));

  *new_inst = *inst;
  
  (new_inst)->expr = copy_imm_expr ((inst)->expr);
  return (new_inst);
}


# 636 "inst.c" 

void
free_inst (inst)
instruction *inst;

{
  if (inst != break_inst)
    
    {
      if ((inst)->expr)
	free ((inst)->expr);
      free (inst);
    }
}









static int sorted_name_table = 0;	




static inst_info name_tbl [] = {


# 1 "./op.h" 1





























































{".alias", 	466, 	0},
{".align", 	467, 	0},
{".ascii", 	468, 	0},
{".asciiz", 	469, 	0},
{".asm0", 	470, 	0},
{".bgnb", 	471, 	0},
{".byte", 	472, 	0},
{".comm", 	473, 	0},
{".data", 	474, 	0},
{".double", 	475, 	0},
{".end", 	478, 	0},
{".endb", 	476, 	0},
{".endr", 	477, 	0},
{".ent", 	479, 	0},
{".err", 	480, 	0},
{".extern", 	481, 	0},
{".file", 	482, 	0},
{".float", 	483, 	0},
{".fmask", 	484, 	0},
{".frame", 	485, 	0},
{".globl", 	486, 	0},
{".half", 	487, 	0},
{".kdata", 	489, 	0},
{".ktext", 	488, 	0},
{".lab", 	490, 	0},
{".lcomm", 	491, 	0},
{".livereg", 	492, 	0},
{".loc", 	493, 	0},
{".mask", 	494, 	0},
{".noalias", 	495, 	0},
{".option", 	496, 	0},
{".rdata", 	497, 	0},
{".repeat", 	498, 	0},
{".sdata", 	499, 	0},
{".set", 	500, 	0},
{".space", 	501, 	0},
{".struct", 	502, 	0},
{".text", 	503, 	0},
{".verstamp", 504, 	0},
{".vreg", 	505, 	0},
{".word", 	506, 	0},
{"abs", 	416, 	2},
{"abs.d", 	264, 	18},
{"abs.s", 	265, 	18},
{"add", 	270, 	15},
{"add.d", 	269, 	20},
{"add.s", 	271, 	20},
{"addi", 	267, 	7},
{"addiu", 	266, 	7},
{"addu", 	268, 	15},
{"and", 	273, 	15},
{"andi", 	272, 	7},
{"b", 	428, 	2},
{"bal", 	417, 	2},
{"bc0f", 	274, 	4},
{"bc0t", 	275, 	4},
{"bc1f", 	276, 	4},
{"bc1t", 	277, 	4},
{"bc2f", 	278, 	4},
{"bc2t", 	279, 	4},
{"bc3f", 	280, 	4},
{"bc3t", 	281, 	4},
{"beq", 	282, 	25},
{"beqz", 	418, 	2},
{"bge", 	420, 	2},
{"bgeu", 	419, 	2},
{"bgez", 	284, 	5},
{"bgezal", 	283, 	5},
{"bgt", 	422, 	2},
{"bgtu", 	421, 	2},
{"bgtz", 	285, 	5},
{"ble", 	424, 	2},
{"bleu", 	423, 	2},
{"blez", 	286, 	5},
{"blt", 	426, 	2},
{"bltu", 	425, 	2},
{"bltz", 	288, 	5},
{"bltzal", 	287, 	5},
{"bne", 	289, 	25},
{"bnez", 	427, 	2},
{"break", 	290, 	10},
{"c.eq.d", 	309, 	19},
{"c.eq.s", 	310, 	19},
{"c.f.d", 	311, 	19},
{"c.f.s", 	312, 	19},
{"c.le.d", 	313, 	19},
{"c.le.s", 	314, 	19},
{"c.lt.d", 	315, 	19},
{"c.lt.s", 	316, 	19},
{"c.nge.d", 	317, 	19},
{"c.nge.s", 	318, 	19},
{"c.ngl.d", 	321, 	19},
{"c.ngl.s", 	322, 	19},
{"c.ngle.d", 	319, 	19},
{"c.ngle.s", 	320, 	19},
{"c.ngt.d", 	323, 	19},
{"c.ngt.s", 	324, 	19},
{"c.ole.d", 	327, 	19},
{"c.ole.s", 	328, 	19},
{"c.olt.d", 	325, 	19},
{"c.olt.s", 	326, 	19},
{"c.seq.d", 	329, 	19},
{"c.seq.s", 	330, 	19},
{"c.sf.d", 	331, 	19},
{"c.sf.s", 	332, 	19},
{"c.ueq.d", 	333, 	19},
{"c.ueq.s", 	334, 	19},
{"c.ule.d", 	337, 	19},
{"c.ule.s", 	338, 	19},
{"c.ult.d", 	335, 	19},
{"c.ult.s", 	336, 	19},
{"c.un.d", 	339, 	19},
{"c.un.s", 	340, 	19},
{"cfc0", 	291, 	11},
{"cfc1", 	292, 	11},
{"cfc2", 	293, 	11},
{"cfc3", 	294, 	11},
{"cop0", 	295, 	22},
{"cop1", 	296, 	22},
{"cop2", 	297, 	22},
{"cop3", 	298, 	22},
{"ctc0", 	299, 	11},
{"ctc1", 	300, 	11},
{"ctc2", 	301, 	11},
{"ctc3", 	302, 	11},
{"cvt.d.s", 	303, 	18},
{"cvt.d.w", 	304, 	18},
{"cvt.s.d", 	305, 	18},
{"cvt.s.w", 	306, 	18},
{"cvt.w.d", 	307, 	18},
{"cvt.w.s", 	308, 	18},
{"div", 	343, 	12},
{"div.d", 	342, 	20},
{"div.s", 	344, 	20},
{"divu", 	341, 	12},
{"j", 	348, 		22},
{"jal", 	346, 	22},
{"jalr", 	345, 	13},
{"jr", 	347, 	9},
{"l.d", 	434, 	2},
{"l.s", 	435, 	2},
{"la", 	429, 	2},
{"lb", 	350, 	8},
{"lbu", 	349, 	8},
{"ld", 	430, 	2},
{"lh", 	352, 	8},
{"lhu", 	351, 	8},
{"li", 	431, 	2},
{"li.d", 	432, 	2},
{"li.s", 	433, 	2},
{"lui", 	353, 	6},
{"lw", 	360, 	8},
{"lwc0", 	354, 	8},
{"lwc1", 	355, 	17},
{"lwc2", 	356, 	8},
{"lwc3", 	357, 	8},
{"lwl", 	358, 	8},
{"lwr", 	359, 	8},
{"mfc0", 	361, 	23},
{"mfc1", 	362, 	23},
{"mfc1.d", 	436, 	2},
{"mfc1.s", 	362, 	23},
{"mfc2", 	363, 	23},
{"mfc3", 	364, 	23},
{"mfhi", 	365, 	10},
{"mflo", 	366, 	10},
{"mov.d", 	367, 	21},
{"mov.s", 	368, 	21},
{"move", 	438, 	2},
{"mtc0", 	369, 	23},
{"mtc1", 	370, 	23},
{"mtc1.d", 	437, 	2},
{"mtc2", 	371, 	23},
{"mtc3", 	372, 	23},
{"mthi", 	373, 	9},
{"mtlo", 	374, 	9},
{"mul", 	441, 	2},
{"mul.d", 	377, 	20},
{"mul.s", 	378, 	20},
{"mulo", 	440, 	2},
{"mulou", 	439, 	2},
{"mult", 	376, 	12},
{"multu", 	375, 	12},
{"neg", 	443, 	2},
{"neg.d", 	379, 	18},
{"neg.s", 	380, 	18},
{"negu", 	442, 	2},
{"nop", 	444, 	2},
{"nor", 	381, 	15},
{"not", 	445, 	2},
{"or", 	383, 	15},
{"ori", 	382, 	7},
{"rem", 	447, 	2},
{"remu", 	446, 	2},
{"rfe", 	385, 	24},
{"rol", 	448, 	2},
{"ror", 	449, 	2},
{"s.d", 	459, 	2},
{"s.s", 	460, 	2},
{"sb", 	386, 	8},
{"sd", 	450, 	2},
{"seq", 	451, 	2},
{"sge", 	453, 	2},
{"sgeu", 	452, 	2},
{"sgt", 	455, 	2},
{"sgtu", 	454, 	2},
{"sh", 	387, 	8},
{"sle", 	457, 	2},
{"sleu", 	456, 	2},
{"sll", 	389, 	14},
{"sllv", 	388, 	15},
{"slt", 	393, 	15},
{"slti", 	391, 	7},
{"sltiu", 	390, 	7},
{"sltu", 	392, 	15},
{"sne", 	458, 	2},
{"sra", 	395, 	14},
{"srav", 	394, 	16},
{"srl", 	397, 	14},
{"srlv", 	396, 	16},
{"sub", 	400, 	15},
{"sub.d", 	399, 	20},
{"sub.s", 	401, 	20},
{"subu", 	398, 	15},
{"sw", 	408, 	8},
{"swc0", 	402, 	8},
{"swc1", 	403, 	17},
{"swc2", 	404, 	8},
{"swc3", 	405, 	8},
{"swl", 	406, 	8},
{"swr", 	407, 	8},
{"syscall", 	409, 	24},
{"tlbp", 	410, 	24},
{"tlbr", 	411, 	24},
{"tlbwi", 	412, 	24},
{"tlbwr", 	413, 	24},
{"ulh", 	462, 	2},
{"ulhu", 	461, 	2},
{"ulw", 	463, 	2},
{"ush", 	464, 	2},
{"usw", 	465, 	2},
{"xor", 	415, 	15},
{"xori", 	414, 	7},
# 668 "inst.c" 2
};





# 677 "inst.c" 

static int
compare_pair_value (p1, p2)
     inst_info *p1, *p2;

{
  if (p1->value1 < p2->value1)
    return (-1);
  else if (p1->value1 > p2->value1)
    return (1);
  else
    return (0);
}




# 697 "inst.c" 

static void
sort_name_table ()

{
  qsort (name_tbl,
	 sizeof (name_tbl) / sizeof (inst_info),
	 sizeof (inst_info),
	 (int(*)()) compare_pair_value);
  sorted_name_table = 1;
}




# 715 "inst.c" 

void
print_inst (addr)
     mem_addr addr;

{
  instruction *inst;
  char buf [128];

  exception_occurred = 0;
  {register mem_addr _addr_ = (mem_addr) ( addr); if (_addr_ >= ((mem_addr) 0x400000) && _addr_ < text_top && !(_addr_ & 0x3)) inst = text_seg [(_addr_ - ((mem_addr) 0x400000)) >> 2]; else if (_addr_ >= ((mem_addr) 0x80000000) && _addr_ < k_text_top && !(_addr_ & 0x3)) inst = k_text_seg [(_addr_ - ((mem_addr) 0x80000000)) >> 2]; else inst = bad_text_read (_addr_);};

  if (exception_occurred)
    {
      error ("Can't print instruction not in text segment (0x%08x)\n", addr);
      return;
    }
  print_inst_internal (buf, 128, inst, addr);
  write_output (message_out, buf);
}


# 740 "inst.c" 

int
print_inst_internal (buf, length, inst, addr)
     char *buf;
     int length;
     instruction *inst;
     mem_addr addr;

{
  char *bp = buf;
  inst_info *entry;

  if (!sorted_name_table)
    sort_name_table ();

  sprintf (buf, "[0x%08x]\t", addr);
  buf += strlen (buf);
  if (inst == 0)
    {
      sprintf (buf, "<none>\n");
      buf += strlen (buf);
      return (buf - bp);
    }
  entry = map_int_to_inst_info (name_tbl,
				sizeof (name_tbl) / sizeof (inst_info),
				(inst)->opcode);
  if (entry == 0)
    {
      sprintf (buf, "<unknown instruction %d>\n", (inst)->opcode);
      buf += strlen (buf);
      return (buf - bp);
    }
  sprintf (buf, "0x%08x  %s", (inst)->encoding, entry->name);
  buf += strlen (buf);
  switch (entry->value2)
    {
    case 4:
      sprintf (buf, " %d", (((inst)->r_t.r_i.r_i.imm << 2) & 0x8000 ? ((inst)->r_t.r_i.r_i.imm << 2) | 0xffff0000 : ((inst)->r_t.r_i.r_i.imm << 2)));
      buf += strlen (buf);
      break;

    case 5:
      sprintf (buf, " $%d %d", (inst)->r_t.r_i.rs, (((inst)->r_t.r_i.r_i.imm << 2) & 0x8000 ? ((inst)->r_t.r_i.r_i.imm << 2) | 0xffff0000 : ((inst)->r_t.r_i.r_i.imm << 2)));
      buf += strlen (buf);
      break;

    case 6:
      sprintf (buf, " $%d, %d", (inst)->r_t.r_i.rt, (inst)->r_t.r_i.r_i.imm);
      buf += strlen (buf);
      break;

    case 7:
      sprintf (buf, " $%d, $%d, %d", (inst)->r_t.r_i.rt, (inst)->r_t.r_i.rs, (inst)->r_t.r_i.r_i.imm);
      buf += strlen (buf);
      break;

    case 25:
      sprintf (buf, " $%d, $%d, %d", (inst)->r_t.r_i.rs, (inst)->r_t.r_i.rt,
	       (((inst)->r_t.r_i.r_i.imm << 2) & 0x8000 ? ((inst)->r_t.r_i.r_i.imm << 2) | 0xffff0000 : ((inst)->r_t.r_i.r_i.imm << 2)));
      buf += strlen (buf);
      break;

    case 8:
      sprintf (buf, " $%d, %d($%d)", (inst)->r_t.r_i.rt, (inst)->r_t.r_i.r_i.imm, (inst)->r_t.r_i.rs);
      buf += strlen (buf);
      break;

    case 9:
      sprintf (buf, " $%d", (inst)->r_t.r_i.rs);
      buf += strlen (buf);
      break;

    case 10:
      sprintf (buf, " $%d", (inst)->r_t.r_i.r_i.r.rd);
      buf += strlen (buf);
      break;

    case 11:
      sprintf (buf, " $%d, $%d", (inst)->r_t.r_i.rt, (inst)->r_t.r_i.r_i.r.rd);
      buf += strlen (buf);
      break;

    case 12:
      sprintf (buf, " $%d, $%d", (inst)->r_t.r_i.rs, (inst)->r_t.r_i.rt);
      buf += strlen (buf);
      break;

    case 13:
      sprintf (buf, " $%d, $%d", (inst)->r_t.r_i.r_i.r.rd, (inst)->r_t.r_i.rs);
      buf += strlen (buf);
      break;

    case 14:
      if ((inst)->encoding == 0)
	{
	  buf -= 3;		
	  sprintf (buf, "nop");
	}
      else
	sprintf (buf, " $%d, $%d, %d", (inst)->r_t.r_i.r_i.r.rd, (inst)->r_t.r_i.rt, (inst)->r_t.r_i.r_i.r.shamt);
      buf += strlen (buf);
      break;

    case 15:
      sprintf (buf, " $%d, $%d, $%d", (inst)->r_t.r_i.r_i.r.rd, (inst)->r_t.r_i.rs, (inst)->r_t.r_i.rt);
      buf += strlen (buf);
      break;

    case 16:
      sprintf (buf, " $%d, $%d, $%d", (inst)->r_t.r_i.r_i.r.rd, (inst)->r_t.r_i.rt, (inst)->r_t.r_i.rs);
      buf += strlen (buf);
      break;

    case 17:
      sprintf (buf, " $f%d, %d($%d)", (inst)->r_t.r_i.rt, (inst)->r_t.r_i.r_i.imm, (inst)->r_t.r_i.rs);
      buf += strlen (buf);
      break;

    case 18:
      sprintf (buf, " $f%d, $f%d", (inst)->r_t.r_i.r_i.r.rd, (inst)->r_t.r_i.rs);
      buf += strlen (buf);
      break;

    case 19:
      sprintf (buf, " $f%d, $f%d", (inst)->r_t.r_i.rs, (inst)->r_t.r_i.rt);
      buf += strlen (buf);
      break;

    case 20:
      sprintf (buf, " $f%d, $f%d, $f%d", (inst)->r_t.r_i.r_i.r.rd, (inst)->r_t.r_i.rs, (inst)->r_t.r_i.rt);
      buf += strlen (buf);
      break;

    case 21:
      sprintf (buf, " $f%d, $f%d", (inst)->r_t.r_i.r_i.r.rd, (inst)->r_t.r_i.rs);
      buf += strlen (buf);
      break;

    case 22:
      sprintf (buf, " 0x%08x", (inst)->r_t.target << 2);
      buf += strlen (buf);
      break;

    case 23:
      sprintf (buf, " $%d, $%d", (inst)->r_t.r_i.rt, (inst)->r_t.r_i.r_i.r.rd);
      buf += strlen (buf);
      break;

    case 24:
      break;

    case 0:
    case 2:
    default:
      fatal_error ("Unknown instruction type in print_inst\n");
    }

  if ((inst)->expr != 0 && (inst)->expr->symbol != 0)
    {
      sprintf (buf, " [");
      buf += strlen (buf);
      if (opcode_is_load_store ((inst)->opcode))
	buf += print_imm_expr (buf, (inst)->expr, (inst)->r_t.r_i.rs);
      else
	buf += print_imm_expr (buf, (inst)->expr, -1);
      sprintf (buf, "]");
      buf += strlen (buf);
    }

  if ((inst)->source_line != 0)
    {
      int line_length = buf - bp;
      int comment_length = 2 + strlen ((inst)->source_line);

      
      if (length > 50)
	{
	  for ( ; line_length < 50; line_length ++)
	    {
	      sprintf (buf, " ");
	      buf += 1;
	    }
	  if (line_length + comment_length >= length)
	    (inst)->source_line [length - line_length - 1] = '\0';
	  sprintf (buf, "; %s", (inst)->source_line);
	  buf += strlen (buf);
	}
    }
  sprintf (buf, "\n");
  buf += strlen (buf);
  return (buf - bp);
}





# 940 "inst.c" 

int
opcode_is_branch (opcode)
     int opcode;

{
  switch (opcode)
    {
    case 282:
    case 418:
    case 420:
    case 419:
    case 284:
    case 283:
    case 422:
    case 421:
    case 285:
    case 424:
    case 423:
    case 286:
    case 426:
    case 425:
    case 288:
    case 287:
    case 289:
    case 427:
    case 276:
    case 277:
      return (1);

    default:
      return (0);
    }
}




# 981 "inst.c" 

int
opcode_is_jump (opcode)
     int opcode;

{
  switch (opcode)
    {
    case 348:
    case 346:
      return (1);

    default:
      return (0);
    }
}



# 1003 "inst.c" 

int
opcode_is_load_store (opcode)
     int opcode;

{
  switch (opcode)
    {
    case 350: return (1);
    case 349: return (1);
    case 352: return (1);
    case 351: return (1);
    case 360: return (1);
    case 354: return (1);
    case 355: return (1);
    case 356: return (1);
    case 357: return (1);
    case 358: return (1);
    case 359: return (1);
    case 386: return (1);
    case 387: return (1);
    case 408: return (1);
    case 402: return (1);
    case 403: return (1);
    case 404: return (1);
    case 405: return (1);
    case 406: return (1);
    case 407: return (1);
    case 434: return (1);
    case 435: return (1);
    case 459: return (1);
    case 460: return (1);
    default: return (0);
    }
}




# 1045 "inst.c" 

int
inst_is_breakpoint (addr)
     mem_addr addr;

{
  instruction *old_inst;

  if (break_inst == 0)
    break_inst = make_r_type_inst (290, 1, 0, 0);

  {register mem_addr _addr_ = (mem_addr) ( addr); if (_addr_ >= ((mem_addr) 0x400000) && _addr_ < text_top && !(_addr_ & 0x3)) old_inst = text_seg [(_addr_ - ((mem_addr) 0x400000)) >> 2]; else if (_addr_ >= ((mem_addr) 0x80000000) && _addr_ < k_text_top && !(_addr_ & 0x3)) old_inst = k_text_seg [(_addr_ - ((mem_addr) 0x80000000)) >> 2]; else old_inst = bad_text_read (_addr_);};
  return (old_inst == break_inst);
}





# 1067 "inst.c" 

instruction *
set_breakpoint (addr)
     mem_addr addr;

{
  instruction *old_inst;

  if (break_inst == 0)
    break_inst = make_r_type_inst (290, 1, 0, 0);

  exception_occurred = 0;
  {register mem_addr _addr_ = (mem_addr) ( addr); if (_addr_ >= ((mem_addr) 0x400000) && _addr_ < text_top && !(_addr_ & 0x3)) old_inst = text_seg [(_addr_ - ((mem_addr) 0x400000)) >> 2]; else if (_addr_ >= ((mem_addr) 0x80000000) && _addr_ < k_text_top && !(_addr_ & 0x3)) old_inst = k_text_seg [(_addr_ - ((mem_addr) 0x80000000)) >> 2]; else old_inst = bad_text_read (_addr_);};
  if (old_inst == break_inst)
    return (0);
  {register mem_addr _addr_ = (mem_addr) (addr); text_modified = 1; if (_addr_ >= ((mem_addr) 0x400000) && _addr_ < text_top && !(_addr_ & 0x3)) text_seg [(_addr_ - ((mem_addr) 0x400000)) >> 2] =  break_inst; else if (_addr_ >= ((mem_addr) 0x80000000) && _addr_ < k_text_top && !(_addr_ & 0x3)) k_text_seg [(_addr_ - ((mem_addr) 0x80000000)) >> 2] =  break_inst; else bad_text_write (_addr_,  break_inst);};
  if (exception_occurred)
    return (0);
  else
    return (old_inst);
}








# 1099 "inst.c" 

imm_expr *
make_imm_expr (offs, sym, pc_rel)
     int offs;
     char *sym;
     int pc_rel;

{
  imm_expr *expr = (imm_expr *) xmalloc (sizeof (imm_expr));

  expr->offset = offs;
  expr->bits = 0;
  expr->pc_relative = pc_rel;
  if (sym != 0)
    expr->symbol = lookup_label (sym);
  else
    expr->symbol = 0;
  return (expr);
}




# 1125 "inst.c" 

imm_expr *
copy_imm_expr (old_expr)
     imm_expr *old_expr;

{
  imm_expr *expr = (imm_expr *) xmalloc (sizeof (imm_expr));

  *expr = *old_expr;
  
  return (expr);
}





# 1145 "inst.c" 

imm_expr *
upper_bits_of_expr (old_expr)
     imm_expr *old_expr;

{
  imm_expr *expr = copy_imm_expr (old_expr);

  expr->bits = 1;
  return (expr);
}





# 1164 "inst.c" 

imm_expr *
lower_bits_of_expr (old_expr)
     imm_expr *old_expr;

{
  imm_expr *expr = copy_imm_expr (old_expr);

  expr->bits = -1;
  return (expr);
}




# 1182 "inst.c" 

imm_expr *
const_imm_expr (value)
     long value;

{
  return (make_imm_expr (value, 0, 0));
}





# 1198 "inst.c" 

imm_expr *
incr_expr_offset (expr, value)
     imm_expr *expr;
     long value;

{
  imm_expr *new_expr = copy_imm_expr (expr);

  new_expr->offset += value;
  return (new_expr);
}




# 1217 "inst.c" 

long
eval_imm_expr (expr)
     imm_expr *expr;

{
  long value;

  if (expr->symbol == 0)
    value = expr->offset;
  else if (((expr->symbol)->addr != 0))
    {
      value = expr->offset + expr->symbol->addr;
      if (expr->symbol->gp_flag) 
	value += gp_midpoint;
    }
  else
    {
      error ("Evaluated undefined symbol: %s\n", expr->symbol->name);
      value = 0;
    }
  if (expr->bits > 0)
    return ((value >> 16) & 0xffff); 
  else if (expr->bits < 0)
    return (value & 0xffff);	
  else
    return (value);
}




# 1252 "inst.c" 

static int
print_imm_expr (buf, expr, base_reg)
     char *buf;
     imm_expr *expr;
     int base_reg;

{
  char *bp = buf;

  if (expr->symbol != 0)
    sprintf (buf, "%s", expr->symbol->name);

  buf += strlen(buf);

  if (expr->pc_relative)
    sprintf (buf, "-0x%08x", -expr->offset);
  else if (expr->offset < -10)
    sprintf (buf, "-%d (-0x%08x)", -expr->offset, -expr->offset);
  else if (expr->offset > 10)
    sprintf (buf, "+%d (0x%08x)", expr->offset, expr->offset);

  buf += strlen(buf);

  if (base_reg != -1 && expr->symbol != 0 &&
      (expr->offset > 10 || expr->offset < -10))
    {
      if (expr->offset == 0 && base_reg != 0)
	sprintf (buf, "+0");
      if (expr->offset != 0 || base_reg != 0)
	sprintf (buf, "($%d)", base_reg);
    }
  buf += strlen(buf);

  return (buf - bp);
}




# 1295 "inst.c" 

int
zero_imm (expr)
     imm_expr *expr;

{
  return (expr->offset == 0 && expr->symbol == 0);
}






# 1312 "inst.c" 

addr_expr *
make_addr_expr (offs, sym, reg_no)
     long offs;
     char *sym;
     int reg_no;

{
  addr_expr *expr = (addr_expr *) xmalloc (sizeof (addr_expr));
  label *lab;

  if (reg_no == 0 && sym != 0 && (lab = lookup_label (sym))->gp_flag)
    {
      expr->reg_no = 28;
      expr->imm = make_imm_expr (offs + lab->addr - gp_midpoint, 0, 0);
    }
  else
    {
      expr->reg_no = reg_no;
      expr->imm = make_imm_expr (offs, (sym ? str_copy (sym) : sym), 0);
    }
  return (expr);
}


# 1340 "inst.c" 

imm_expr *
addr_expr_imm (expr)
addr_expr *expr;

{
  return (expr->imm);
}


# 1353 "inst.c" 

int
addr_expr_reg (expr)
addr_expr *expr;

{
  return (expr->reg_no);
}











static int sorted_i_opcode_table = 0; 




static inst_info i_opcode_tbl [] = {


# 1 "./op.h" 1





























































{".alias", 	466, 		-1},
{".align", 	467, 		-1},
{".ascii", 	468, 		-1},
{".asciiz", 	469, 		-1},
{".asm0", 	470, 		-1},
{".bgnb", 	471, 		-1},
{".byte", 	472, 		-1},
{".comm", 	473, 		-1},
{".data", 	474, 		-1},
{".double", 	475, 		-1},
{".end", 	478, 		-1},
{".endb", 	476, 		-1},
{".endr", 	477, 		-1},
{".ent", 	479, 		-1},
{".err", 	480, 		-1},
{".extern", 	481, 		-1},
{".file", 	482, 		-1},
{".float", 	483, 		-1},
{".fmask", 	484, 		-1},
{".frame", 	485, 		-1},
{".globl", 	486, 		-1},
{".half", 	487, 		-1},
{".kdata", 	489, 		-1},
{".ktext", 	488, 		-1},
{".lab", 	490, 		-1},
{".lcomm", 	491, 		-1},
{".livereg", 	492, 		-1},
{".loc", 	493, 		-1},
{".mask", 	494, 		-1},
{".noalias", 	495, 		-1},
{".option", 	496, 		-1},
{".rdata", 	497, 		-1},
{".repeat", 	498, 		-1},
{".sdata", 	499, 		-1},
{".set", 	500, 		-1},
{".space", 	501, 		-1},
{".struct", 	502, 		-1},
{".text", 	503, 		-1},
{".verstamp", 504, 		-1},
{".vreg", 	505, 		-1},
{".word", 	506, 		-1},
{"abs", 	416, 		-1},
{"abs.d", 	264, 	0x46200005},
{"abs.s", 	265, 	0x46000005},
{"add", 	270, 		0x00000020},
{"add.d", 	269, 	0x46200000},
{"add.s", 	271, 	0x46000000},
{"addi", 	267, 		0x20000000},
{"addiu", 	266, 		0x24000000},
{"addu", 	268, 		0x00000021},
{"and", 	273, 		0x00000024},
{"andi", 	272, 		0x30000000},
{"b", 	428, 		-1},
{"bal", 	417, 		-1},
{"bc0f", 	274, 		0x41000000},
{"bc0t", 	275, 		0x41010000},
{"bc1f", 	276, 		0x45000000},
{"bc1t", 	277, 		0x45010000},
{"bc2f", 	278, 		0x49000000},
{"bc2t", 	279, 		0x49010000},
{"bc3f", 	280, 		0x4d000000},
{"bc3t", 	281, 		0x4d010000},
{"beq", 	282, 		0x10000000},
{"beqz", 	418, 		-1},
{"bge", 	420, 		-1},
{"bgeu", 	419, 		-1},
{"bgez", 	284, 		0x04010000},
{"bgezal", 	283, 		0x04110000},
{"bgt", 	422, 		-1},
{"bgtu", 	421, 		-1},
{"bgtz", 	285, 		0x1c000000},
{"ble", 	424, 		-1},
{"bleu", 	423, 		-1},
{"blez", 	286, 		0x18000000},
{"blt", 	426, 		-1},
{"bltu", 	425, 		-1},
{"bltz", 	288, 		0x04000000},
{"bltzal", 	287, 		0x04100000},
{"bne", 	289, 		0x14000000},
{"bnez", 	427, 		-1},
{"break", 	290, 		0x0000000d},
{"c.eq.d", 	309, 	0x46200032},
{"c.eq.s", 	310, 	0x46000032},
{"c.f.d", 	311, 	0x46200030},
{"c.f.s", 	312, 	0x46000030},
{"c.le.d", 	313, 	0x4620003e},
{"c.le.s", 	314, 	0x4600003e},
{"c.lt.d", 	315, 	0x4620003c},
{"c.lt.s", 	316, 	0x4600003c},
{"c.nge.d", 	317, 	0x4620003d},
{"c.nge.s", 	318, 	0x4600003d},
{"c.ngl.d", 	321, 	0x4620003b},
{"c.ngl.s", 	322, 	0x4600003b},
{"c.ngle.d", 	319, 	0x46200039},
{"c.ngle.s", 	320, 	0x46000039},
{"c.ngt.d", 	323, 	0x4620003f},
{"c.ngt.s", 	324, 	0x4600003f},
{"c.ole.d", 	327, 	0x46200036},
{"c.ole.s", 	328, 	0x46000036},
{"c.olt.d", 	325, 	0x46200034},
{"c.olt.s", 	326, 	0x46000034},
{"c.seq.d", 	329, 	0x4620003a},
{"c.seq.s", 	330, 	0x4600003a},
{"c.sf.d", 	331, 	0x46200038},
{"c.sf.s", 	332, 	0x46000038},
{"c.ueq.d", 	333, 	0x46200033},
{"c.ueq.s", 	334, 	0x46000033},
{"c.ule.d", 	337, 	0x46200037},
{"c.ule.s", 	338, 	0x46000037},
{"c.ult.d", 	335, 	0x46200035},
{"c.ult.s", 	336, 	0x46000035},
{"c.un.d", 	339, 	0x46200031},
{"c.un.s", 	340, 	0x46000031},
{"cfc0", 	291, 		0x40400000},
{"cfc1", 	292, 		0x44400000},
{"cfc2", 	293, 		0x48400000},
{"cfc3", 	294, 		0x4c400000},
{"cop0", 	295, 		0x40200000},
{"cop1", 	296, 		0x44200000},
{"cop2", 	297, 		0x48200000},
{"cop3", 	298, 		0x4c200000},
{"ctc0", 	299, 		0x40c00000},
{"ctc1", 	300, 		0x44c00000},
{"ctc2", 	301, 		0x48c00000},
{"ctc3", 	302, 		0x4cc00000},
{"cvt.d.s", 	303, 	0x46000021},
{"cvt.d.w", 	304, 	0x46800021},
{"cvt.s.d", 	305, 	0x46200020},
{"cvt.s.w", 	306, 	0x46800020},
{"cvt.w.d", 	307, 	0x46200024},
{"cvt.w.s", 	308, 	0x46000024},
{"div", 	343, 		0x0000001a},
{"div.d", 	342, 	0x46200003},
{"div.s", 	344, 	0x46000003},
{"divu", 	341, 		0x0000001b},
{"j", 	348, 		0x08000000},
{"jal", 	346, 		0x0c000000},
{"jalr", 	345, 		0x00000009},
{"jr", 	347, 		0x00000008},
{"l.d", 	434, 		-1},
{"l.s", 	435, 		-1},
{"la", 	429, 		-1},
{"lb", 	350, 		0x80000000},
{"lbu", 	349, 		0x90000000},
{"ld", 	430, 		-1},
{"lh", 	352, 		0x84000000},
{"lhu", 	351, 		0x94000000},
{"li", 	431, 		-1},
{"li.d", 	432, 		-1},
{"li.s", 	433, 		-1},
{"lui", 	353, 		0x3c000000},
{"lw", 	360, 		0x8c000000},
{"lwc0", 	354, 		0xc0000000},
{"lwc1", 	355, 	0xc4000000},
{"lwc2", 	356, 		0xc8000000},
{"lwc3", 	357, 		0xcc000000},
{"lwl", 	358, 		0x88000000},
{"lwr", 	359, 		0x98000000},
{"mfc0", 	361, 		0x40000000},
{"mfc1", 	362, 		0x44000000},
{"mfc1.d", 	436, 		-1},
{"mfc1.s", 	362, 		0x44000000},
{"mfc2", 	363, 		0x48000000},
{"mfc3", 	364, 		0x4c000000},
{"mfhi", 	365, 		0x00000010},
{"mflo", 	366, 		0x00000012},
{"mov.d", 	367, 	0x46200006},
{"mov.s", 	368, 	0x46000006},
{"move", 	438, 		-1},
{"mtc0", 	369, 		0x40800000},
{"mtc1", 	370, 		0x44800000},
{"mtc1.d", 	437, 		-1},
{"mtc2", 	371, 		0x48800000},
{"mtc3", 	372, 		0x4c800000},
{"mthi", 	373, 		0x00000011},
{"mtlo", 	374, 		0x00000013},
{"mul", 	441, 		-1},
{"mul.d", 	377, 	0x46200002},
{"mul.s", 	378, 	0x46000002},
{"mulo", 	440, 		-1},
{"mulou", 	439, 		-1},
{"mult", 	376, 		0x00000018},
{"multu", 	375, 		0x00000019},
{"neg", 	443, 		-1},
{"neg.d", 	379, 	0x46200007},
{"neg.s", 	380, 	0x46000007},
{"negu", 	442, 		-1},
{"nop", 	444, 		-1},
{"nor", 	381, 		0x00000027},
{"not", 	445, 		-1},
{"or", 	383, 		0x00000025},
{"ori", 	382, 		0x34000000},
{"rem", 	447, 		-1},
{"remu", 	446, 		-1},
{"rfe", 	385, 	0x42000010},
{"rol", 	448, 		-1},
{"ror", 	449, 		-1},
{"s.d", 	459, 		-1},
{"s.s", 	460, 		-1},
{"sb", 	386, 		0xa0000000},
{"sd", 	450, 		-1},
{"seq", 	451, 		-1},
{"sge", 	453, 		-1},
{"sgeu", 	452, 		-1},
{"sgt", 	455, 		-1},
{"sgtu", 	454, 		-1},
{"sh", 	387, 		0xa4000000},
{"sle", 	457, 		-1},
{"sleu", 	456, 		-1},
{"sll", 	389, 		0x00000000},
{"sllv", 	388, 		0x00000004},
{"slt", 	393, 		0x0000002a},
{"slti", 	391, 		0x28000000},
{"sltiu", 	390, 		0x2c000000},
{"sltu", 	392, 		0x0000002b},
{"sne", 	458, 		-1},
{"sra", 	395, 		0x00000003},
{"srav", 	394, 		0x00000007},
{"srl", 	397, 		0x00000002},
{"srlv", 	396, 		0x00000006},
{"sub", 	400, 		0x00000022},
{"sub.d", 	399, 	0x46200001},
{"sub.s", 	401, 	0x46000001},
{"subu", 	398, 		0x00000023},
{"sw", 	408, 		0xac000000},
{"swc0", 	402, 		0xe0000000},
{"swc1", 	403, 	0xe4000000},
{"swc2", 	404, 		0xe8000000},
{"swc3", 	405, 		0xec000000},
{"swl", 	406, 		0xa8000000},
{"swr", 	407, 		0xb8000000},
{"syscall", 	409, 	0x0000000c},
{"tlbp", 	410, 	0x42000008},
{"tlbr", 	411, 	0x42000001},
{"tlbwi", 	412, 	0x42000002},
{"tlbwr", 	413, 	0x42000006},
{"ulh", 	462, 		-1},
{"ulhu", 	461, 		-1},
{"ulw", 	463, 		-1},
{"ush", 	464, 		-1},
{"usw", 	465, 		-1},
{"xor", 	415, 		0x00000026},
{"xori", 	414, 		0x38000000},
# 1381 "inst.c" 2
};




# 1389 "inst.c" 

static void
sort_i_opcode_table ()

{
  qsort (i_opcode_tbl,
	 sizeof (i_opcode_tbl) / sizeof (inst_info),
	 sizeof (inst_info),
	 (int(*)()) compare_pair_value);
  sorted_i_opcode_table = 1;
}





# 1408 "inst.c" 

long
inst_encode (inst)
     instruction *inst;

{
  long a_opcode = 0;
  inst_info *entry;

  if (inst == 0)
    return (0);
  if (!sorted_i_opcode_table)
    sort_i_opcode_table ();
  if (!sorted_name_table)
    sort_name_table ();

  entry = map_int_to_inst_info (i_opcode_tbl,
				sizeof (i_opcode_tbl) / sizeof (inst_info),
				(inst)->opcode);
  if (entry == 0)
    return 0;

  a_opcode = entry->value2;
  entry = map_int_to_inst_info (name_tbl,
				sizeof (name_tbl) / sizeof (inst_info),
				(inst)->opcode);

  switch (entry->value2)
    {
    case 4:
      return (a_opcode
	      | ((inst)->r_t.r_i.r_i.imm & 0xffff));

    case 5:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rs) & 0x1f) <<  21)
	      | ((inst)->r_t.r_i.r_i.imm & 0xffff));

    case 6:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rs) & 0x1f) <<  21)
	      | ((((inst)->r_t.r_i.rt) & 0x1f) <<  16)
	      | ((inst)->r_t.r_i.r_i.imm & 0xffff));

    case 7:
    case 25:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rs) & 0x1f) <<  21)
	      | ((((inst)->r_t.r_i.rt) & 0x1f) <<  16)
	      | ((inst)->r_t.r_i.r_i.imm & 0xffff));

    case 8:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rs) & 0x1f) <<  21)
	      | ((((inst)->r_t.r_i.rt) & 0x1f) <<  16)
	      | ((inst)->r_t.r_i.r_i.imm & 0xffff));

    case 9:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rs) & 0x1f) <<  21));

    case 10:
      return (a_opcode
	      | ((((inst)->r_t.r_i.r_i.r.rd) & 0x1f) <<  11));

    case 11:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rt) & 0x1f) <<  16)
	      | ((((inst)->r_t.r_i.r_i.r.rd) & 0x1f) <<  11));

    case 12:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rs) & 0x1f) <<  21)
	      | ((((inst)->r_t.r_i.rt) & 0x1f) <<  16));

    case 13:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rs) & 0x1f) <<  21)
	      | ((((inst)->r_t.r_i.r_i.r.rd) & 0x1f) <<  11));

    case 14:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rt) & 0x1f) <<  16)
	      | ((((inst)->r_t.r_i.r_i.r.rd) & 0x1f) <<  11)
	      | ((((inst)->r_t.r_i.r_i.r.shamt) & 0x1f) <<  6));

    case 15:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rs) & 0x1f) <<  21)
	      | ((((inst)->r_t.r_i.rt) & 0x1f) <<  16)
	      | ((((inst)->r_t.r_i.r_i.r.rd) & 0x1f) <<  11));

    case 16:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rs) & 0x1f) <<  21)
	      | ((((inst)->r_t.r_i.rt) & 0x1f) <<  16)
	      | ((((inst)->r_t.r_i.r_i.r.rd) & 0x1f) <<  11));

    case 17:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rs) & 0x1f) <<  21)
	      | ((((inst)->r_t.r_i.rt) & 0x1f) <<  16)
	      | ((inst)->r_t.r_i.r_i.imm & 0xffff));

    case 18:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rs) & 0x1f) <<  11)
	      | ((((inst)->r_t.r_i.r_i.r.rd) & 0x1f) <<  6));

    case 19:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rt) & 0x1f) <<  16)
	      | ((((inst)->r_t.r_i.rs) & 0x1f) <<  11)
	      | (inst)->r_t.r_i.r_i.imm & 0xf);

    case 20:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rt) & 0x1f) <<  16)
	      | ((((inst)->r_t.r_i.rs) & 0x1f) <<  11)
	      | ((((inst)->r_t.r_i.r_i.r.rd) & 0x1f) <<  6));

    case 21:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rs) & 0x1f) <<  11)
	      | ((((inst)->r_t.r_i.r_i.r.rd) & 0x1f) <<  6));

    case 22:
      return (a_opcode
	      | (inst)->r_t.target);

    case 23:
      return (a_opcode
	      | ((((inst)->r_t.r_i.rt) & 0x1f) <<  16)
	      | ((((inst)->r_t.r_i.r_i.r.rd) & 0x1f) <<  11));

    case 24:
      return (a_opcode);

    case 0:
    case 2:
    default:
      fatal_error ("Unknown instruction type in inst_encoding\n");
      return (0);		
    }
}






static int sorted_a_opcode_table = 0; 




static inst_info a_opcode_tbl [] = {


# 1 "./op.h" 1





























































{".alias", 		-1, 	466},
{".align", 		-1, 	467},
{".ascii", 		-1, 	468},
{".asciiz", 		-1, 	469},
{".asm0", 		-1, 	470},
{".bgnb", 		-1, 	471},
{".byte", 		-1, 	472},
{".comm", 		-1, 	473},
{".data", 		-1, 	474},
{".double", 		-1, 	475},
{".end", 		-1, 	478},
{".endb", 		-1, 	476},
{".endr", 		-1, 	477},
{".ent", 		-1, 	479},
{".err", 		-1, 	480},
{".extern", 		-1, 	481},
{".file", 		-1, 	482},
{".float", 		-1, 	483},
{".fmask", 		-1, 	484},
{".frame", 		-1, 	485},
{".globl", 		-1, 	486},
{".half", 		-1, 	487},
{".kdata", 		-1, 	489},
{".ktext", 		-1, 	488},
{".lab", 		-1, 	490},
{".lcomm", 		-1, 	491},
{".livereg", 		-1, 	492},
{".loc", 		-1, 	493},
{".mask", 		-1, 	494},
{".noalias", 		-1, 	495},
{".option", 		-1, 	496},
{".rdata", 		-1, 	497},
{".repeat", 		-1, 	498},
{".sdata", 		-1, 	499},
{".set", 		-1, 	500},
{".space", 		-1, 	501},
{".struct", 		-1, 	502},
{".text", 		-1, 	503},
{".verstamp", 		-1, 504},
{".vreg", 		-1, 	505},
{".word", 		-1, 	506},
{"abs", 		-1, 	416},
{"abs.d", 	0x46200005, 	264},
{"abs.s", 	0x46000005, 	265},
{"add", 		0x00000020, 	270},
{"add.d", 	0x46200000, 	269},
{"add.s", 	0x46000000, 	271},
{"addi", 		0x20000000, 	267},
{"addiu", 		0x24000000, 	266},
{"addu", 		0x00000021, 	268},
{"and", 		0x00000024, 	273},
{"andi", 		0x30000000, 	272},
{"b", 		-1, 	428},
{"bal", 		-1, 	417},
{"bc0f", 		0x41000000, 	274},
{"bc0t", 		0x41010000, 	275},
{"bc1f", 		0x45000000, 	276},
{"bc1t", 		0x45010000, 	277},
{"bc2f", 		0x49000000, 	278},
{"bc2t", 		0x49010000, 	279},
{"bc3f", 		0x4d000000, 	280},
{"bc3t", 		0x4d010000, 	281},
{"beq", 		0x10000000, 	282},
{"beqz", 		-1, 	418},
{"bge", 		-1, 	420},
{"bgeu", 		-1, 	419},
{"bgez", 		0x04010000, 	284},
{"bgezal", 		0x04110000, 	283},
{"bgt", 		-1, 	422},
{"bgtu", 		-1, 	421},
{"bgtz", 		0x1c000000, 	285},
{"ble", 		-1, 	424},
{"bleu", 		-1, 	423},
{"blez", 		0x18000000, 	286},
{"blt", 		-1, 	426},
{"bltu", 		-1, 	425},
{"bltz", 		0x04000000, 	288},
{"bltzal", 		0x04100000, 	287},
{"bne", 		0x14000000, 	289},
{"bnez", 		-1, 	427},
{"break", 		0x0000000d, 	290},
{"c.eq.d", 	0x46200032, 	309},
{"c.eq.s", 	0x46000032, 	310},
{"c.f.d", 	0x46200030, 	311},
{"c.f.s", 	0x46000030, 	312},
{"c.le.d", 	0x4620003e, 	313},
{"c.le.s", 	0x4600003e, 	314},
{"c.lt.d", 	0x4620003c, 	315},
{"c.lt.s", 	0x4600003c, 	316},
{"c.nge.d", 	0x4620003d, 	317},
{"c.nge.s", 	0x4600003d, 	318},
{"c.ngl.d", 	0x4620003b, 	321},
{"c.ngl.s", 	0x4600003b, 	322},
{"c.ngle.d", 	0x46200039, 	319},
{"c.ngle.s", 	0x46000039, 	320},
{"c.ngt.d", 	0x4620003f, 	323},
{"c.ngt.s", 	0x4600003f, 	324},
{"c.ole.d", 	0x46200036, 	327},
{"c.ole.s", 	0x46000036, 	328},
{"c.olt.d", 	0x46200034, 	325},
{"c.olt.s", 	0x46000034, 	326},
{"c.seq.d", 	0x4620003a, 	329},
{"c.seq.s", 	0x4600003a, 	330},
{"c.sf.d", 	0x46200038, 	331},
{"c.sf.s", 	0x46000038, 	332},
{"c.ueq.d", 	0x46200033, 	333},
{"c.ueq.s", 	0x46000033, 	334},
{"c.ule.d", 	0x46200037, 	337},
{"c.ule.s", 	0x46000037, 	338},
{"c.ult.d", 	0x46200035, 	335},
{"c.ult.s", 	0x46000035, 	336},
{"c.un.d", 	0x46200031, 	339},
{"c.un.s", 	0x46000031, 	340},
{"cfc0", 		0x40400000, 	291},
{"cfc1", 		0x44400000, 	292},
{"cfc2", 		0x48400000, 	293},
{"cfc3", 		0x4c400000, 	294},
{"cop0", 		0x40200000, 	295},
{"cop1", 		0x44200000, 	296},
{"cop2", 		0x48200000, 	297},
{"cop3", 		0x4c200000, 	298},
{"ctc0", 		0x40c00000, 	299},
{"ctc1", 		0x44c00000, 	300},
{"ctc2", 		0x48c00000, 	301},
{"ctc3", 		0x4cc00000, 	302},
{"cvt.d.s", 	0x46000021, 	303},
{"cvt.d.w", 	0x46800021, 	304},
{"cvt.s.d", 	0x46200020, 	305},
{"cvt.s.w", 	0x46800020, 	306},
{"cvt.w.d", 	0x46200024, 	307},
{"cvt.w.s", 	0x46000024, 	308},
{"div", 		0x0000001a, 	343},
{"div.d", 	0x46200003, 	342},
{"div.s", 	0x46000003, 	344},
{"divu", 		0x0000001b, 	341},
{"j", 		0x08000000, 	348},
{"jal", 		0x0c000000, 	346},
{"jalr", 		0x00000009, 	345},
{"jr", 		0x00000008, 	347},
{"l.d", 		-1, 	434},
{"l.s", 		-1, 	435},
{"la", 		-1, 	429},
{"lb", 		0x80000000, 	350},
{"lbu", 		0x90000000, 	349},
{"ld", 		-1, 	430},
{"lh", 		0x84000000, 	352},
{"lhu", 		0x94000000, 	351},
{"li", 		-1, 	431},
{"li.d", 		-1, 	432},
{"li.s", 		-1, 	433},
{"lui", 		0x3c000000, 	353},
{"lw", 		0x8c000000, 	360},
{"lwc0", 		0xc0000000, 	354},
{"lwc1", 	0xc4000000, 	355},
{"lwc2", 		0xc8000000, 	356},
{"lwc3", 		0xcc000000, 	357},
{"lwl", 		0x88000000, 	358},
{"lwr", 		0x98000000, 	359},
{"mfc0", 		0x40000000, 	361},
{"mfc1", 		0x44000000, 	362},
{"mfc1.d", 		-1, 	436},
{"mfc1.s", 		0x44000000, 	362},
{"mfc2", 		0x48000000, 	363},
{"mfc3", 		0x4c000000, 	364},
{"mfhi", 		0x00000010, 	365},
{"mflo", 		0x00000012, 	366},
{"mov.d", 	0x46200006, 	367},
{"mov.s", 	0x46000006, 	368},
{"move", 		-1, 	438},
{"mtc0", 		0x40800000, 	369},
{"mtc1", 		0x44800000, 	370},
{"mtc1.d", 		-1, 	437},
{"mtc2", 		0x48800000, 	371},
{"mtc3", 		0x4c800000, 	372},
{"mthi", 		0x00000011, 	373},
{"mtlo", 		0x00000013, 	374},
{"mul", 		-1, 	441},
{"mul.d", 	0x46200002, 	377},
{"mul.s", 	0x46000002, 	378},
{"mulo", 		-1, 	440},
{"mulou", 		-1, 	439},
{"mult", 		0x00000018, 	376},
{"multu", 		0x00000019, 	375},
{"neg", 		-1, 	443},
{"neg.d", 	0x46200007, 	379},
{"neg.s", 	0x46000007, 	380},
{"negu", 		-1, 	442},
{"nop", 		-1, 	444},
{"nor", 		0x00000027, 	381},
{"not", 		-1, 	445},
{"or", 		0x00000025, 	383},
{"ori", 		0x34000000, 	382},
{"rem", 		-1, 	447},
{"remu", 		-1, 	446},
{"rfe", 	0x42000010, 	385},
{"rol", 		-1, 	448},
{"ror", 		-1, 	449},
{"s.d", 		-1, 	459},
{"s.s", 		-1, 	460},
{"sb", 		0xa0000000, 	386},
{"sd", 		-1, 	450},
{"seq", 		-1, 	451},
{"sge", 		-1, 	453},
{"sgeu", 		-1, 	452},
{"sgt", 		-1, 	455},
{"sgtu", 		-1, 	454},
{"sh", 		0xa4000000, 	387},
{"sle", 		-1, 	457},
{"sleu", 		-1, 	456},
{"sll", 		0x00000000, 	389},
{"sllv", 		0x00000004, 	388},
{"slt", 		0x0000002a, 	393},
{"slti", 		0x28000000, 	391},
{"sltiu", 		0x2c000000, 	390},
{"sltu", 		0x0000002b, 	392},
{"sne", 		-1, 	458},
{"sra", 		0x00000003, 	395},
{"srav", 		0x00000007, 	394},
{"srl", 		0x00000002, 	397},
{"srlv", 		0x00000006, 	396},
{"sub", 		0x00000022, 	400},
{"sub.d", 	0x46200001, 	399},
{"sub.s", 	0x46000001, 	401},
{"subu", 		0x00000023, 	398},
{"sw", 		0xac000000, 	408},
{"swc0", 		0xe0000000, 	402},
{"swc1", 	0xe4000000, 	403},
{"swc2", 		0xe8000000, 	404},
{"swc3", 		0xec000000, 	405},
{"swl", 		0xa8000000, 	406},
{"swr", 		0xb8000000, 	407},
{"syscall", 	0x0000000c, 	409},
{"tlbp", 	0x42000008, 	410},
{"tlbr", 	0x42000001, 	411},
{"tlbwi", 	0x42000002, 	412},
{"tlbwr", 	0x42000006, 	413},
{"ulh", 		-1, 	462},
{"ulhu", 		-1, 	461},
{"ulw", 		-1, 	463},
{"ush", 		-1, 	464},
{"usw", 		-1, 	465},
{"xor", 		0x00000026, 	415},
{"xori", 		0x38000000, 	414},
# 1568 "inst.c" 2
};




# 1576 "inst.c" 

static void
sort_a_opcode_table ()

{
  qsort (a_opcode_tbl,
	 sizeof (a_opcode_tbl) / sizeof (inst_info),
	 sizeof (inst_info),
	 (int(*)()) compare_pair_value);
  sorted_a_opcode_table = 1;
}





# 1595 "inst.c" 

instruction *
  inst_decode (value)
unsigned long value;

{
  long a_opcode = value & 0xfc000000;
  inst_info *entry;
  long i_opcode;

  if (a_opcode == 0)		
    a_opcode |= (value & 0x3f);
  else if (a_opcode == 0x04000000) 
    a_opcode |= (value & 0x001f0000);
  else if (a_opcode == 0x40000000) 
    a_opcode |= (value & 0x03e00000) | (value & 0x1f);
  else if (a_opcode == 0x44000000) 
    {
      a_opcode |= (value & 0x03e00000);
      if ((value & 0xff000000) == 0x45000000)
	a_opcode |= (value & 0x00010000); 
      else
	a_opcode |= (value & 0x3f);
    }
  else if (a_opcode == 0x48000000 
	   || a_opcode == 0x4c000000)
    a_opcode |= (value & 0x03e00000);


  if (!sorted_a_opcode_table)
    sort_a_opcode_table ();
  if (!sorted_name_table)
    sort_name_table ();

  entry = map_int_to_inst_info (a_opcode_tbl,
				sizeof (a_opcode_tbl) / sizeof (inst_info),
				a_opcode);
  if (entry == 0)
    return (mk_r_inst (value, 0, 0, 0, 0, 0)); 

  i_opcode = entry->value2;

  switch (map_int_to_inst_info (name_tbl,
				sizeof (name_tbl) / sizeof (inst_info),
				i_opcode)->value2)
    {
    case 4:
      return (mk_i_inst (value, i_opcode, 0, 0, value & 0xffff));

    case 5:
      return (mk_i_inst (value, i_opcode, ((value) >>  21) & 0x1f, 0, value & 0xffff));

    case 6:
      return (mk_i_inst (value, i_opcode, ((value) >>  21) & 0x1f, ((value) >>  16) & 0x1f,
			 value & 0xffff));

    case 7:
    case 25:
      return (mk_i_inst (value, i_opcode, ((value) >>  21) & 0x1f, ((value) >>  16) & 0x1f,
			 value & 0xffff));

    case 8:
      return (mk_i_inst (value, i_opcode, ((value) >>  21) & 0x1f, ((value) >>  16) & 0x1f,
			 value & 0xffff));

    case 9:
      return (mk_r_inst (value, i_opcode, ((value) >>  21) & 0x1f, 0, 0, 0));

    case 10:
      return (mk_r_inst (value, i_opcode, 0, 0, ((value) >>  11) & 0x1f, 0));

    case 11:
      return (mk_r_inst (value, i_opcode, 0, ((value) >>  16) & 0x1f, ((value) >>  11) & 0x1f,
			 0));

    case 12:
      return (mk_r_inst (value, i_opcode, ((value) >>  21) & 0x1f, ((value) >>  16) & 0x1f,
			 0, 0));

    case 13:
      return (mk_r_inst (value, i_opcode, ((value) >>  21) & 0x1f, 0, ((value) >>  11) & 0x1f,
			 0));

    case 14:
      return (mk_r_inst (value, i_opcode, 0, ((value) >>  16) & 0x1f, ((value) >>  11) & 0x1f,
			 ((value) >>  6) & 0x1f));

    case 15:
      return (mk_r_inst (value, i_opcode, ((value) >>  21) & 0x1f, ((value) >>  16) & 0x1f,
			 ((value) >>  11) & 0x1f, 0));

    case 16:
      return (mk_r_inst (value, i_opcode, ((value) >>  21) & 0x1f, ((value) >>  16) & 0x1f,
			 ((value) >>  11) & 0x1f, 0));

    case 17:
      return (mk_i_inst (value, i_opcode, ((value) >>  21) & 0x1f, ((value) >>  16) & 0x1f,
			 value & 0xffff));

    case 18:
      return (mk_r_inst (value, i_opcode, ((value) >>  11) & 0x1f, 0, ((value) >>  6) & 0x1f,
			 0));

    case 19:
      {
	instruction *inst = mk_r_inst (value, i_opcode, ((value) >>  11) & 0x1f,
				       ((value) >>  16) & 0x1f, 0, 0);
	(inst)->r_t.r_i.r_i.imm = value & 0xf;
	return (inst);
      }

    case 20:
      return (mk_r_inst (value, i_opcode, ((value) >>  11) & 0x1f, ((value) >>  16) & 0x1f,
			 ((value) >>  6) & 0x1f, 0));

    case 21:
      return (mk_r_inst (value, i_opcode, ((value) >>  11) & 0x1f, 0, ((value) >>  6) & 0x1f,
			 0));

    case 22:
      return (mk_j_inst (value, i_opcode, value & 0x2ffffff));

    case 23:
      return (mk_r_inst (value, i_opcode, 0, ((value) >>  16) & 0x1f, ((value) >>  11) & 0x1f,
			 0));

    case 24:
      return (mk_r_inst (value, i_opcode, 0, 0, 0, 0));

    case 0:
    case 2:
    default:
      return (mk_r_inst (value, 0, 0, 0, 0, 0)); 
    }
}


# 1735 "inst.c" 

static instruction *
mk_r_inst (value, opcode, rs, rt, rd, shamt)
     unsigned long value;
     int opcode, rs, rt, rd, shamt;

{
  instruction *inst = (instruction *) zmalloc (sizeof (instruction));

  (inst)->opcode = opcode;
  (inst)->r_t.r_i.rs = rs;
  (inst)->r_t.r_i.rt = rt;
  (inst)->r_t.r_i.r_i.r.rd = rd;
  (inst)->r_t.r_i.r_i.r.shamt = shamt;
  (inst)->encoding = value;
  (inst)->expr = 0;
  return (inst);
}


# 1758 "inst.c" 

static instruction *
mk_i_inst (value, opcode, rs, rt, offset)
     unsigned long value;
     int opcode, rs, rt, offset;

{
  instruction *inst = (instruction *) zmalloc (sizeof (instruction));

  (inst)->opcode = opcode;
  (inst)->r_t.r_i.rs = rs;
  (inst)->r_t.r_i.rt = rt;
  (inst)->r_t.r_i.r_i.imm = offset;
  (inst)->encoding = value;
  (inst)->expr = 0;
  return (inst);
}

# 1779 "inst.c" 

static instruction *
mk_j_inst (value, opcode, target)
     unsigned long value;
     int opcode, target;

{
  instruction *inst = (instruction *) zmalloc (sizeof (instruction));

  (inst)->opcode = opcode;
  (inst)->r_t.target = target;
  (inst)->encoding = value;
  (inst)->expr = 0;
  return (inst);
}




# 1801 "inst.c" 

void
test_assembly (inst)
     instruction *inst;

{
  instruction *new_inst = inst_decode (inst_encode (inst));

  inst_cmp (inst, new_inst);
  free_inst (new_inst);
}


# 1817 "inst.c" 

static void
inst_cmp (inst1, inst2)
     instruction *inst1, *inst2;

{
  char buf[1024];

  if (memcmp (inst1, inst2, sizeof (instruction) - 4) != 0)
    {
      printf ("=================== Not Equal ===================\n");
      print_inst_internal (buf, 1024, inst1, 0);
      printf ("%s\n", buf);
      print_inst_internal (buf, 1024, inst2, 0);
      printf ("%s\n", buf);
      printf ("=================== Not Equal ===================\n");
    }
}
