
/* This file is added for ptt. It basically turns */
/* each macro definition without arguments into a */
/* procedure. */

#include "header.h"

	/* macro to create scroll #'s with probability of occurrence */
/* #define newscroll() (scprob[rund(81)]) */
int newscroll(void) { return (scprob[rund(81)]); }
	/* macro to return a potion # created with probability of occurrence */
/* #define newpotion() (potprob[rund(41)]) */
int newpotion(void) { return (potprob[rund(41)]); }
	/* macro to return the + points on created leather armor */
/* #define newleather() (nlpts[rund(c[HARDGAME]?13:15)]) */
int newleather(void) { return (nlpts[rund(c[HARDGAME]?13:15)]); }
	/* macro to return the + points on chain armor */
/* #define newchain() (nch[rund(10)]) */
int newchain(void) { return (nch[rund(10)]); }
	/* macro to return + points on plate armor */
/* #define newplate() (nplt[rund(c[HARDGAME]?4:12)]) */
int newplate(void) { return (nplt[rund(c[HARDGAME]?4:12)]); }
	/* macro to return + points on new daggers */
/* #define newdagger() (ndgg[rund(13)]) */
int newdagger(void) { return (ndgg[rund(13)]); }
	/* macro to return + points on new swords */
/* #define newsword() (nsw[rund(c[HARDGAME]?6:13)]) */
int newsword(void) { return (nsw[rund(c[HARDGAME]?6:13)]); }
	/* macro to destroy object at present location */
/* #define forget() (item[playerx][playery]=know[playerx][playery]=0) */
void forget(void) { (item[playerx][playery]=know[playerx][playery]=0); }
	/* macro to wipe out a monster at a location */

#ifdef VT100
	/* macro to turn on bold display for the terminal */
/* #define setbold() (lprcat(boldon?"\33[1m":"\33[7m")) */
int setbold(void) { return (lprcat(boldon?"\33[1m":"\33[7m")); }
	/* macro to turn off bold display for the terminal */
/* #define resetbold() (lprcat("\33[m")) */
void resetbold(void) { (lprcat("\33[m")); }
	/* macro to setup the scrolling region for the terminal */
/* #define setscroll() (lprcat("\33[20;24r")) */
void setscroll(void) { (lprcat("\33[20;24r")); }
	/* macro to clear the scrolling region for the terminal */
/* #define resetscroll() (lprcat("\33[;24r")) */
void resetscroll(void) { (lprcat("\33[;24r")); }
	/* macro to clear the screen and home the cursor */
/* #define clear() (lprcat("\33[2J\33[f"), cbak[SPELLS]= -50) */
void clear(void) { (lprcat("\33[2J\33[f"), cbak[SPELLS]= -50); }
/* #define cltoeoln() lprcat("\33[K") */
void cltoeoln(void) { lprcat("\33[K"); }
#else
#if 0
	/* defines below are for use in the termcap mode only */
#define ST_START 1
#define ST_END   2
#define BOLD     3
#define END_BOLD 4
#define CLEAR    5
#define CL_LINE  6
#define CL_DOWN 14
#define CURSOR  15
#endif
	/* macro to turn on bold display for the terminal */
/* #define setbold() (*lpnt++ = ST_START) */
void setbold(void) { (*lpnt++ = ST_START); }
	/* macro to turn off bold display for the terminal */
/* #define resetbold() (*lpnt++ = ST_END) */
void resetbold(void) { (*lpnt++ = ST_END); }
	/* macro to setup the scrolling region for the terminal */
/* #define setscroll() enable_scroll=1 */
void setscroll(void) { enable_scroll=1; }
	/* macro to clear the scrolling region for the terminal */
/* #define resetscroll() enable_scroll=0 */
void resetscroll(void) { enable_scroll=0; }
	/* macro to clear the screen and home the cursor */
/* #define clear() (*lpnt++ =CLEAR, cbak[SPELLS]= -50) */
void clear(void) { (*lpnt++ =CLEAR, cbak[SPELLS]= -50); }

	/* macro to clear to end of line */
/* #define cltoeoln() (*lpnt++ = CL_LINE) */
void cltoeoln(void) { (*lpnt++ = CL_LINE); }
#endif
