# 1 "run.c.orig" 

























# 29 "run.c.orig" 




# 1 "/usr/include/math.h" 1



















extern double	__infinity();
extern double	acos();
extern double	asin();
extern double	atan();
extern double	atan2();
extern double	ceil();
extern double	cos();
extern double	cosh();
extern double	exp();
extern double	fabs();
extern double	floor();
extern double	fmod();
extern double	frexp();
extern double	ldexp();
extern double	log();
extern double	log10();
extern double	modf();
extern double	pow();
extern double	sin();
extern double	sinh();
extern double	sqrt();
extern double	tan();
extern double	tanh();


# 1 "/usr/include/floatingpoint.h" 1

















# 1 "/usr/include/sys/ieeefp.h" 1

















enum fp_direction_type 		
	{
	fp_nearest	= 0,
	fp_tozero	= 1,
	fp_positive	= 2,
	fp_negative	= 3
	} ;

# 34 "/usr/include/sys/ieeefp.h" 

# 43 "/usr/include/sys/ieeefp.h" 


# 53 "/usr/include/sys/ieeefp.h" 

enum fp_precision_type		
	{
	fp_extended	= 0,
	fp_single	= 1,
	fp_double	= 2,
	fp_precision_3	= 3
	} ;


# 73 "/usr/include/sys/ieeefp.h" 

enum fp_exception_type		
	{
	fp_inexact	= 0,
	fp_division	= 1,
	fp_underflow	= 2,
	fp_overflow	= 3,
	fp_invalid	= 4
	} ;


enum fp_class_type		
	{
	fp_zero		= 0,
	fp_subnormal	= 1,
	fp_normal	= 2,
	fp_infinity   	= 3,
	fp_quiet	= 4,
	fp_signaling	= 5
	} ;


# 19 "/usr/include/floatingpoint.h" 2



typedef float   single;
typedef unsigned long extended[3];	
# 26 "/usr/include/floatingpoint.h" 

typedef struct {
	unsigned long   u[4];
}               quadruple;	




typedef unsigned fp_exception_field_type;




typedef int     sigfpe_code_type;	

typedef void    (*sigfpe_handler_type) ();








extern enum fp_direction_type fp_direction;




extern enum fp_precision_type fp_precision;




extern fp_exception_field_type fp_accrued_exceptions;











typedef char    decimal_string[512];


typedef struct {
	enum fp_class_type fpclass;
	int             sign;
	int             exponent;
	decimal_string  ds;	


	int             more;	


	int             ndigits;


}
                decimal_record;

enum decimal_form {
	fixed_form,		



	floating_form		

};

typedef struct {
	enum fp_direction_type rd;
	
	enum decimal_form df;	
	int             ndigits;
}
                decimal_mode;

enum decimal_string_form {	
	invalid_form,		
	whitespace_form,	
	fixed_int_form,		
	fixed_intdot_form,	
	fixed_dotfrac_form,	
	fixed_intdotfrac_form,	
	floating_int_form,	
	floating_intdot_form,	
	floating_dotfrac_form,	
	floating_intdotfrac_form,	
	inf_form,		
	infinity_form,		
	nan_form,		
	nanstring_form		
};



extern void     double_to_decimal();
extern void     quadruple_to_decimal();
extern char    *econvert();
extern char    *fconvert();
extern char    *gconvert();
extern char    *qeconvert();
extern char    *qfconvert();
extern char    *qgconvert();





extern sigfpe_handler_type ieee_handlers[5];







extern sigfpe_handler_type sigfpe();

extern void     single_to_decimal();
extern void     extended_to_decimal();

extern void     decimal_to_single();
extern void     decimal_to_double();
extern void     decimal_to_extended();
extern void     decimal_to_quadruple();

extern char    *seconvert();
extern char    *sfconvert();
extern char    *sgconvert();

extern void     string_to_decimal();
extern void     file_to_decimal();
extern void     func_to_decimal();



extern double   atof();



extern int      errno;

extern double   strtod();


# 48 "/usr/include/math.h" 2
extern double	acosh();
extern double	asinh();
extern double	atanh();
extern double	cbrt();
extern double	copysign();
extern double	erf();
extern double	erfc();
extern double	expm1();
extern int	finite();
extern double	hypot();
extern double	j0();
extern double	j1();
extern double	jn();
extern double	lgamma();
extern double	log1p();
extern double	rint();
extern double	y0();
extern double	y1();
extern double	yn();








enum fp_pi_type {
	fp_pi_infinite	= 0,	
	fp_pi_66	= 1,	
	fp_pi_53	= 2	
};




extern enum	fp_pi_type fp_pi;




extern enum	fp_class_type fp_class();
extern int	ieee_flags();
extern int	ieee_handler();
extern void	ieee_retrospective();
extern int	ilogb();
extern double	infinity();
extern int	irint();
extern int	isinf();
extern int	isnan();
extern int	isnormal();
extern int	issubnormal();
extern int	iszero();
extern double	logb();
extern double	max_normal();
extern double	max_subnormal();
extern double	min_normal();
extern double	min_subnormal();
extern double	nextafter();
extern void	nonstandard_arithmetic();
extern double	quiet_nan();
extern double	remainder();
extern double	scalb();
extern double	scalbn();
extern double	signaling_nan();
extern int	signbit();
extern double	significand();
extern void	standard_arithmetic();




extern double	acospi();
extern double	aint();
extern double	anint();
extern double	annuity();
extern double	asinpi();
extern double	atan2pi();
extern double	atanpi();
extern double	compound();
extern double	cospi();
extern double	exp10();
extern double	exp2();
extern double	log2();
extern int	nint();
extern void	sincos();
extern void	sincospi();
extern double	sinpi();
extern double	tanpi();
extern int	matherr();



















# 161 "/usr/include/math.h" 












# 177 "/usr/include/math.h" 







extern int		 ir_finite_();
extern enum fp_class_type ir_fp_class_();
extern int		 ir_ilogb_();
extern int		 ir_irint_();
extern int		 ir_isinf_();
extern int		 ir_isnan_();
extern int		 ir_isnormal_();
extern int		 ir_issubnormal_();
extern int		 ir_iszero_();
extern int		 ir_nint_();
extern int		 ir_signbit_();
extern void		 r_sincos_();
extern void		 r_sincospi_();
extern double r_acos_();
extern double r_acosh_();
extern double r_acospi_();
extern double r_aint_();
extern double r_anint_();
extern double r_annuity_();
extern double r_asin_();
extern double r_asinh_();
extern double r_asinpi_();
extern double r_atan2_();
extern double r_atan2pi_();
extern double r_atan_();
extern double r_atanh_();
extern double r_atanpi_();
extern double r_cbrt_();
extern double r_ceil_();
extern double r_compound_();
extern double r_copysign_();
extern double r_cos_();
extern double r_cosh_();
extern double r_cospi_();
extern double r_erf_();
extern double r_erfc_();
extern double r_exp10_();
extern double r_exp2_();
extern double r_exp_();
extern double r_expm1_();
extern double r_fabs_();
extern double r_floor_();
extern double r_fmod_();
extern double r_hypot_();
extern double r_infinity_();
extern double r_j0_();
extern double r_j1_();
extern double r_jn_();
extern double r_lgamma_();
extern double r_log10_();
extern double r_log1p_();
extern double r_log2_();
extern double r_log_();
extern double r_logb_();
extern double r_max_normal_();
extern double r_max_subnormal_();
extern double r_min_normal_();
extern double r_min_subnormal_();
extern double r_nextafter_();
extern double r_pow_();
extern double r_quiet_nan_();
extern double r_remainder_();
extern double r_rint_();
extern double r_scalb_();
extern double r_scalbn_();
extern double r_signaling_nan_();
extern double r_significand_();
extern double r_sin_();
extern double r_sinh_();
extern double r_sinpi_();
extern double r_sqrt_();
extern double r_tan_();
extern double r_tanh_();
extern double r_tanpi_();
extern double r_y0_();
extern double r_y1_();
extern double r_yn_();














struct exception {
	int type;
	char *name;
	double arg1;
	double arg2;
	double retval;
};































extern int	signgam;





extern double cabs();	



extern double drem();	


extern double gamma();	






# 34 "run.c.orig" 2
# 1 "/usr/include/stdio.h" 1





extern	struct	_iobuf {
	int	_cnt;
	unsigned char *_ptr;
	unsigned char *_base;
	int	_bufsiz;
	short	_flag;
	char	_file;		
} _iob[];



















# 36 "/usr/include/stdio.h" 

















extern struct _iobuf	*fopen();
extern struct _iobuf	*fdopen();
extern struct _iobuf	*freopen();
extern struct _iobuf	*popen();
extern struct _iobuf	*tmpfile();
extern long	ftell();
extern char	*fgets();
extern char	*gets();
extern char	*sprintf();
extern char	*ctermid();
extern char	*cuserid();
extern char	*tempnam();
extern char	*tmpnam();






# 35 "run.c.orig" 2

# 1 "./spim.h" 1
























# 27 "./spim.h" 


























# 57 "./spim.h" 

# 1 "/usr/include/memory.h" 1





extern char
	*memccpy(),
	*memchr(),
	*memcpy(),
	*memset();
extern int memcmp();


# 59 "./spim.h" 2



# 66 "./spim.h" 

double atof ();
int atoi ();
int free ();
char *malloc ();
int strcmp ();
char *strcpy ();
char *strncpy ();







typedef unsigned long mem_addr;














































































































typedef struct strint
{
  char *name;
  int value1;
  int value2;
} inst_info;

# 201 "./spim.h" 

typedef int port;






# 223 "./spim.h" 

int console_input_available ();
void control_c_seen ();
void error ();
void fatal_error ();
char get_console_char ();
void put_console_char ();
void read_input ();
int run_error ();
void write_output ();





extern int bare_machine;	
extern int quiet;		
extern int source_file;		


extern port message_out, console_out, console_in;

extern int mapped_io;		

# 250 "./spim.h" 


extern mem_addr program_starting_address;

extern long initial_text_size;

extern long initial_data_size;

extern long initial_data_limit;

extern long initial_stack_size;

extern long initial_stack_limit;

extern long initial_k_text_size;

extern long initial_k_data_size;

extern long initial_k_data_limit;
# 37 "run.c.orig" 2
# 1 "./spim-utils.h" 1



























# 45 "./spim-utils.h" 

void add_breakpoint ();
void end_of_assembly_file ();
void delete_breakpoint ();
void fatal_error ();
void initialize_registers ();
void initialize_run_stack ();
void initialize_world ();
void list_breakpoints ();
inst_info *map_int_to_inst_info ();
inst_info *map_string_to_inst_info ();
int read_assembly_file ();
int run_program ();
mem_addr starting_address ();
char *str_copy ();
void write_startup_message ();
char *xmalloc ();
char *zmalloc ();

# 38 "run.c.orig" 2
# 1 "./inst.h" 1





























typedef struct immexpr
{
  long offset;			
  struct lab *symbol;		
  short bits;			
  short pc_relative;		
} imm_expr;





typedef struct addrexpr
{
  unsigned char reg_no;		
  imm_expr *imm;		
} addr_expr;






typedef struct inst_s
{
  short opcode;

  union
    {
      
      struct
	{
	  unsigned char rs;
	  unsigned char rt;

	  union
	    {
	      short imm;

	      struct
		{
		  unsigned char rd;
		  unsigned char shamt;
		} r;
	    } r_i;
	} r_i;

      
      long target;
    } r_t;

  unsigned long encoding;
  imm_expr *expr;
  char *source_line;
} instruction;

























































































# 210 "./inst.h" 

imm_expr *addr_expr_imm ();
int addr_expr_reg ();
imm_expr *const_imm_expr ();
imm_expr *copy_imm_expr ();
instruction *copy_inst ();
mem_addr current_text_pc ();
long eval_imm_expr ();
void free_inst ();
void i_type_inst ();
void i_type_inst_free ();
void increment_text_pc ();
imm_expr *incr_expr_offset ();
instruction *inst_decode ();
long inst_encode ();
int inst_is_breakpoint ();
void j_type_inst ();
void k_text_begins_at_point ();
void k_text_begins_at_point ();
imm_expr *lower_bits_of_expr ();
addr_expr *make_addr_expr ();
imm_expr *make_imm_expr ();
int opcode_is_branch ();
int opcode_is_jump ();
int opcode_is_load_store ();
void print_inst ();
int print_inst_internal ();
void r_cond_type_inst ();
void r_sh_type_inst ();
void r_type_inst ();
instruction *set_breakpoint ();
void store_instruction ();
void text_begins_at_point ();
imm_expr *upper_bits_of_expr ();
void user_kernel_text_segment ();
int zero_imm ();

# 39 "run.c.orig" 2
# 1 "./mem.h" 1































typedef long mem_word;




extern instruction **text_seg;

extern int text_modified;	



extern mem_addr text_top;









extern mem_word *data_seg;

extern int data_modified;	

extern short *data_seg_h;	












extern char *data_seg_b;	



extern mem_addr data_top;

extern mem_addr gp_midpoint;	




extern mem_word *stack_seg;

extern short *stack_seg_h;	

extern char *stack_seg_b;	

extern mem_addr stack_bot;








extern instruction **k_text_seg;



extern mem_addr k_text_top;




extern mem_word *k_data_seg;

extern short *k_data_seg_h;

char *k_data_seg_b;



extern mem_addr k_data_top;

















































































































































# 272 "./mem.h" 

mem_word bad_mem_read ();
void bad_mem_write ();
instruction *bad_text_read ();
void bad_text_write ();
void check_memory_mapped_IO ();
void expand_data ();
void expand_k_data ();
void expand_stack ();
void make_memory ();
void print_mem ();

# 40 "run.c.orig" 2
# 1 "./reg.h" 1

























typedef long reg_word;
typedef unsigned long u_reg_word;




extern reg_word R[32];

extern reg_word HI, LO;
# 37 "./reg.h" 


extern mem_addr PC, nPC;



























extern double *FPR;		
extern float *FGR;		
extern int *FWR;		


extern int FP_reg_present;	
extern int FP_reg_poison;	
extern int FP_spec_load;	



































extern reg_word CpCond[4], CCR[4][32], CPR[4][32];





int exception_occurred;















# 41 "run.c.orig" 2
# 1 "./sym-tbl.h" 1

























typedef struct lab_use
{
  instruction *inst;		
  mem_addr addr;
  struct lab_use *next;
} label_use;




typedef struct lab
{
  char *name;			
  long addr;			
  unsigned global_flag : 1;	
  unsigned gp_flag : 1;		
  unsigned const_flag : 1;	
  struct lab *next;		
  struct lab *next_local;	
  label_use *uses;		
} label;			








# 68 "./sym-tbl.h" 

mem_addr find_symbol_address ();
void flush_local_labels ();
void initialize_symbol_table ();
label *label_is_defined ();
label *lookup_label ();
label *make_label_global ();
void print_symbols ();
label *record_label ();
void record_data_uses_symbol ();
void record_inst_uses_symbol ();
void resolve_a_label ();
void resolve_label_uses ();

# 42 "run.c.orig" 2
# 1 "./y.tab.h" 1


























































































































































































































































# 43 "run.c.orig" 2
# 1 "./read-aout.h" 1



























# 30 "./read-aout.h" 

int read_aout_file ();





extern int program_break;	
# 44 "run.c.orig" 2
# 1 "./mips-syscall.h" 1





























# 36 "./mips-syscall.h" 

int do_syscall ();
void handle_exception ();
void initialize_prog_fds ();
void kill_prog_fds ();
void print_syscall_usage ();


# 45 "run.c.orig" 2
# 1 "./run.h" 1



























# 30 "./run.h" 

int run_spim ();

# 46 "run.c.orig" 2


extern int errno;

# 52 "run.c.orig" 

long atol ();





# 61 "run.c.orig" 

static void long_multiply ();






































































# 136 "run.c.orig" 

int
run_spim (initial_PC, steps_to_run, display)
     mem_addr initial_PC;
     int steps_to_run;
     int display;

{
  register instruction *inst;
  static reg_word *delayed_addr1 = 0, delayed_value1;
  static reg_word *delayed_addr2 = 0, delayed_value2;
  int step, step_size, next_step;

  PC = initial_PC;
  if (!bare_machine && mapped_io)
    next_step = 100;
  else
    next_step = steps_to_run;	

  for (step_size = ((next_step) < ( steps_to_run) ? (next_step) : ( steps_to_run));
       steps_to_run > 0;
       steps_to_run -= step_size, step_size = ((next_step) < ( steps_to_run) ? (next_step) : ( steps_to_run)))
    {
      if (!bare_machine && mapped_io)
	

	check_memory_mapped_IO ();
      

      for (step = 0; step < step_size; step += 1)
	{

	  R[0] = 0;		

	  {register mem_addr _addr_ = (mem_addr) ( PC); if (_addr_ >= ((mem_addr) 0x400000) && _addr_ < text_top && !(_addr_ & 0x3)) inst = text_seg [(_addr_ - ((mem_addr) 0x400000)) >> 2]; else if (_addr_ >= ((mem_addr) 0x80000000) && _addr_ < k_text_top && !(_addr_ & 0x3)) inst = k_text_seg [(_addr_ - ((mem_addr) 0x80000000)) >> 2]; else inst = bad_text_read (_addr_);};

	  if (exception_occurred)
	    {
	      exception_occurred = 0;
	      (CPR[0][14]) = PC & 0xfffffffc; 
	      handle_exception();
	      continue;
	    }
	  else if (inst == 0)
	    run_error ("Attempt to execute non-instruction at 0x%08x\n", PC);
	  else if ((inst)->expr != 0
		   && (inst)->expr->symbol != 0
		   && (inst)->expr->symbol->addr == 0)
	    {
	      error ("Instruction references undefined symbol at 0x%08x\n",
		     PC);
	      print_inst (PC);
	      run_error ("");
	    }

	  if (display)
	    print_inst (PC);

# 196 "run.c.orig" 


	  if (bare_machine) {  if (delayed_addr2 != 0) *delayed_addr2 = delayed_value2; delayed_addr2 = delayed_addr1; delayed_value2 = delayed_value1; delayed_addr1 = 0; };

	  switch ((inst)->opcode)
	    {
	    case 270:
	      {
		register reg_word vs = R[(inst)->r_t.r_i.rs], vt = R[(inst)->r_t.r_i.rt];
		register reg_word sum = vs + vt;

		if (((( vs) & 0x80000000) == (( vt) & 0x80000000) && (( vs) & 0x80000000) != ((sum) & 0x80000000)))
		  { if (((12)<= 17) || ((CPR[0][12]) & 0x1)) { (CPR[0][13]) = (12) << 2; exception_occurred = 1; (CPR[0][14]) = PC; (CPR[0][12]) = ((CPR[0][12]) & 0xffffffc0) | (((CPR[0][12]) & 0xf) << 2);  break; } };
		R[(inst)->r_t.r_i.r_i.r.rd] = sum;
		break;
	      }

	    case 267:
	      {
		register reg_word vs = R[(inst)->r_t.r_i.rs], imm = (short) (inst)->r_t.r_i.r_i.imm;
		register reg_word sum = vs + imm;

		if (((( vs) & 0x80000000) == (( imm) & 0x80000000) && (( vs) & 0x80000000) != ((sum) & 0x80000000)))
		  { if (((12)<= 17) || ((CPR[0][12]) & 0x1)) { (CPR[0][13]) = (12) << 2; exception_occurred = 1; (CPR[0][14]) = PC; (CPR[0][12]) = ((CPR[0][12]) & 0xffffffc0) | (((CPR[0][12]) & 0xf) << 2);  break; } };
		R[(inst)->r_t.r_i.rt] = sum;
		break;
	      }

	    case 266:
	      R[(inst)->r_t.r_i.rt] = R[(inst)->r_t.r_i.rs] + (short) (inst)->r_t.r_i.r_i.imm;
	      break;

	    case 268:
	      R[(inst)->r_t.r_i.r_i.r.rd] = R[(inst)->r_t.r_i.rs] + R[(inst)->r_t.r_i.rt];
	      break;

	    case 273:
	      R[(inst)->r_t.r_i.r_i.r.rd] = R[(inst)->r_t.r_i.rs] & R[(inst)->r_t.r_i.rt];
	      break;

	    case 272:
	      R[(inst)->r_t.r_i.rt] = R[(inst)->r_t.r_i.rs] & (0xffff & (inst)->r_t.r_i.r_i.imm);
	      break;

	    case 274:
	    case 278:
	    case 280:
	      
# 244 "run.c.orig" 
{if (CpCond[(inst)->opcode - 274] == 0) { mem_addr target = ( 			   PC + ((((inst)->r_t.r_i.r_i.imm) & 0x8000 ? ((inst)->r_t.r_i.r_i.imm) | 0xffff0000 : ((inst)->r_t.r_i.r_i.imm)) << 2)); if (bare_machine)  target += 4; {if (bare_machine) run_spim (PC + 4, 1, display);  PC = (target) - 4; } } };
	      break;

	    case 275:
	    case 279:
	    case 281:
	      
# 251 "run.c.orig" 
{if (CpCond[(inst)->opcode - 275] != 0) { mem_addr target = ( 			   PC + ((((inst)->r_t.r_i.r_i.imm) & 0x8000 ? ((inst)->r_t.r_i.r_i.imm) | 0xffff0000 : ((inst)->r_t.r_i.r_i.imm)) << 2)); if (bare_machine)  target += 4; {if (bare_machine) run_spim (PC + 4, 1, display);  PC = (target) - 4; } } };
	      break;

	    case 282:
	      
# 256 "run.c.orig" 
{if (R[(inst)->r_t.r_i.rs] == R[(inst)->r_t.r_i.rt]) { mem_addr target = ( 			   PC + ((((inst)->r_t.r_i.r_i.imm) & 0x8000 ? ((inst)->r_t.r_i.r_i.imm) | 0xffff0000 : ((inst)->r_t.r_i.r_i.imm)) << 2)); if (bare_machine)  target += 4; {if (bare_machine) run_spim (PC + 4, 1, display);  PC = (target) - 4; } } };
	      break;

	    case 284:
	      
# 261 "run.c.orig" 
{if (((R[(inst)->r_t.r_i.rs]) & 0x80000000) == 0) { mem_addr target = ( 			   PC + ((((inst)->r_t.r_i.r_i.imm) & 0x8000 ? ((inst)->r_t.r_i.r_i.imm) | 0xffff0000 : ((inst)->r_t.r_i.r_i.imm)) << 2)); if (bare_machine)  target += 4; {if (bare_machine) run_spim (PC + 4, 1, display);  PC = (target) - 4; } } };
	      break;

	    case 283:
	      if (bare_machine)
		R[31] = PC + 2 * 4;
	      else
		R[31] = PC + 4;
	      
# 270 "run.c.orig" 
{if (((R[(inst)->r_t.r_i.rs]) & 0x80000000) == 0) { mem_addr target = ( 			   PC + ((((inst)->r_t.r_i.r_i.imm) & 0x8000 ? ((inst)->r_t.r_i.r_i.imm) | 0xffff0000 : ((inst)->r_t.r_i.r_i.imm)) << 2)); if (bare_machine)  target += 4; {if (bare_machine) run_spim (PC + 4, 1, display);  PC = (target) - 4; } } };
	      break;

	    case 285:
	      
# 275 "run.c.orig" 
{if (R[(inst)->r_t.r_i.rs] != 0 && ((R[(inst)->r_t.r_i.rs]) & 0x80000000) == 0) { mem_addr target = ( 			   PC + ((((inst)->r_t.r_i.r_i.imm) & 0x8000 ? ((inst)->r_t.r_i.r_i.imm) | 0xffff0000 : ((inst)->r_t.r_i.r_i.imm)) << 2)); if (bare_machine)  target += 4; {if (bare_machine) run_spim (PC + 4, 1, display);  PC = (target) - 4; } } };
	      break;

	    case 286:
	      
# 280 "run.c.orig" 
{if (R[(inst)->r_t.r_i.rs] == 0 || ((R[(inst)->r_t.r_i.rs]) & 0x80000000) != 0) { mem_addr target = ( 			   PC + ((((inst)->r_t.r_i.r_i.imm) & 0x8000 ? ((inst)->r_t.r_i.r_i.imm) | 0xffff0000 : ((inst)->r_t.r_i.r_i.imm)) << 2)); if (bare_machine)  target += 4; {if (bare_machine) run_spim (PC + 4, 1, display);  PC = (target) - 4; } } };
	      break;

	    case 288:
	      
# 285 "run.c.orig" 
{if (((R[(inst)->r_t.r_i.rs]) & 0x80000000) != 0) { mem_addr target = ( 			   PC + ((((inst)->r_t.r_i.r_i.imm) & 0x8000 ? ((inst)->r_t.r_i.r_i.imm) | 0xffff0000 : ((inst)->r_t.r_i.r_i.imm)) << 2)); if (bare_machine)  target += 4; {if (bare_machine) run_spim (PC + 4, 1, display);  PC = (target) - 4; } } };
	      break;

	    case 287:
	      if (bare_machine)
		R[31] = PC + 2 * 4;
	      else
		R[31] = PC + 4;
	      
# 294 "run.c.orig" 
{if (((R[(inst)->r_t.r_i.rs]) & 0x80000000) != 0) { mem_addr target = ( 			   PC + ((((inst)->r_t.r_i.r_i.imm) & 0x8000 ? ((inst)->r_t.r_i.r_i.imm) | 0xffff0000 : ((inst)->r_t.r_i.r_i.imm)) << 2)); if (bare_machine)  target += 4; {if (bare_machine) run_spim (PC + 4, 1, display);  PC = (target) - 4; } } };
	      break;

	    case 289:
	      
# 299 "run.c.orig" 
{if (R[(inst)->r_t.r_i.rs] != R[(inst)->r_t.r_i.rt]) { mem_addr target = ( 			   PC + ((((inst)->r_t.r_i.r_i.imm) & 0x8000 ? ((inst)->r_t.r_i.r_i.imm) | 0xffff0000 : ((inst)->r_t.r_i.r_i.imm)) << 2)); if (bare_machine)  target += 4; {if (bare_machine) run_spim (PC + 4, 1, display);  PC = (target) - 4; } } };
	      break;

	    case 290:
	      if ((inst)->r_t.r_i.r_i.r.rd == 1)
		
		{ if (((9)<= 17) || ((CPR[0][12]) & 0x1)) { (CPR[0][13]) = (9) << 2; exception_occurred = 1; (CPR[0][14]) = PC; (CPR[0][12]) = ((CPR[0][12]) & 0xffffffc0) | (((CPR[0][12]) & 0xf) << 2);  return (1); } }
	      else
		{ if (((9)<= 17) || ((CPR[0][12]) & 0x1)) { (CPR[0][13]) = (9) << 2; exception_occurred = 1; (CPR[0][14]) = PC; (CPR[0][12]) = ((CPR[0][12]) & 0xffffffc0) | (((CPR[0][12]) & 0xf) << 2);  break; } };

	    case 291:
	    case 293:
	    case 294:
	      R[(inst)->r_t.r_i.rt] = CCR[(inst)->opcode - 291][(inst)->r_t.r_i.r_i.r.rd];
	      break;

	    case 295:
	    case 296:
	    case 297:
	    case 298:
	      CCR[(inst)->opcode - 295][(inst)->r_t.r_i.r_i.r.rd] = R[(inst)->r_t.r_i.rt];
	      break;

	    case 299:
	    case 301:
	    case 302:
	      CCR[(inst)->opcode - 299][(inst)->r_t.r_i.r_i.r.rd] = R[(inst)->r_t.r_i.rt];
	      break;

	    case 343:
	      if (R[(inst)->r_t.r_i.rt] != 0)
		{
		  LO = (reg_word) R[(inst)->r_t.r_i.rs] / (reg_word) R[(inst)->r_t.r_i.rt];
		  HI = (reg_word) R[(inst)->r_t.r_i.rs] % (reg_word) R[(inst)->r_t.r_i.rt];
		}
	      break;

	    case 341:
	      if (R[(inst)->r_t.r_i.rt] != 0)
		{
		  LO = ((u_reg_word) R[(inst)->r_t.r_i.rs] / (u_reg_word) R[(inst)->r_t.r_i.rt]);
		  HI = ((u_reg_word) R[(inst)->r_t.r_i.rs] % (u_reg_word) R[(inst)->r_t.r_i.rt]);
		}
	      break;

	    case 348:
	      {if (bare_machine) run_spim (PC + 4, 1, display);  PC = (((PC & 0xf0000000) | (inst)->r_t.target << 2)) - 4; };
	      break;

	    case 346:
	      if (bare_machine)
		R[31] = PC + 2 * 4;
	      else
		R[31] = PC + 4;
	      {if (bare_machine) run_spim (PC + 4, 1, display);  PC = (((PC & 0xf0000000) | ((inst)->r_t.target << 2))) - 4; };
	      break;

	    case 345:
	      {
		mem_addr tmp = R[(inst)->r_t.r_i.rs];

		if (bare_machine)
		  R[(inst)->r_t.r_i.r_i.r.rd] = PC + 2 * 4;
		else
		  R[(inst)->r_t.r_i.r_i.r.rd] = PC + 4;
		{if (bare_machine) run_spim (PC + 4, 1, display);  PC = (tmp) - 4; };
	      }
	      break;

	    case 347:
	      {
		mem_addr tmp = R[(inst)->r_t.r_i.rs];

		{if (bare_machine) run_spim (PC + 4, 1, display);  PC = (tmp) - 4; };
	      }
	      break;

	    case 350:
	      
# 378 "run.c.orig" 
{reg_word tmp; {register mem_addr _addr_ = (mem_addr) ( ( R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm)); if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top) tmp = data_seg_b [_addr_ - ((mem_addr) 0x10000000)]; else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000)) tmp = stack_seg_b [_addr_ - stack_bot]; else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top) tmp = k_data_seg_b [_addr_ - ((mem_addr) 0x90000000)]; else tmp = bad_mem_read (_addr_, 0, (mem_word *)&tmp);}; *( 			 &R[(inst)->r_t.r_i.rt]) = tmp & ( 0xffffffff); };
	      break;

	    case 349:
	      
# 383 "run.c.orig" 
{reg_word tmp; {register mem_addr _addr_ = (mem_addr) ( ( R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm)); if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top) tmp = data_seg_b [_addr_ - ((mem_addr) 0x10000000)]; else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000)) tmp = stack_seg_b [_addr_ - stack_bot]; else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top) tmp = k_data_seg_b [_addr_ - ((mem_addr) 0x90000000)]; else tmp = bad_mem_read (_addr_, 0, (mem_word *)&tmp);}; *( 			 &R[(inst)->r_t.r_i.rt]) = tmp & ( 0xff); };
	      break;

	    case 352:
	      
# 388 "run.c.orig" 
{reg_word tmp; {register mem_addr _addr_ = (mem_addr) ( ( R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm)); if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top && !(_addr_ & 0x1)) tmp = data_seg_h [(_addr_ - ((mem_addr) 0x10000000)) >> 1]; else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000) && !(_addr_ & 0x1)) tmp = stack_seg_h [(_addr_ - stack_bot) >> 1]; else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top && !(_addr_ & 0x1)) tmp = k_data_seg_h [(_addr_ - ((mem_addr) 0x90000000)) >> 1]; else tmp = bad_mem_read (_addr_, 0x1, (mem_word *)&tmp);}; *( 			 &R[(inst)->r_t.r_i.rt]) = tmp & ( 0xffffffff); };
	      break;

	    case 351:
	      
# 393 "run.c.orig" 
{reg_word tmp; {register mem_addr _addr_ = (mem_addr) ( ( R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm)); if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top && !(_addr_ & 0x1)) tmp = data_seg_h [(_addr_ - ((mem_addr) 0x10000000)) >> 1]; else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000) && !(_addr_ & 0x1)) tmp = stack_seg_h [(_addr_ - stack_bot) >> 1]; else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top && !(_addr_ & 0x1)) tmp = k_data_seg_h [(_addr_ - ((mem_addr) 0x90000000)) >> 1]; else tmp = bad_mem_read (_addr_, 0x1, (mem_word *)&tmp);}; *( 			 &R[(inst)->r_t.r_i.rt]) = tmp & ( 0xffff); };
	      break;

	    case 353:
	      R[(inst)->r_t.r_i.rt] = ((inst)->r_t.r_i.r_i.imm << 16) & 0xffff0000;
	      break;

	    case 360:
	      
# 402 "run.c.orig" 
{reg_word tmp; {register mem_addr _addr_ = (mem_addr) ( ( R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm)); if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top && !(_addr_ & 0x3)) tmp = data_seg [(_addr_ - ((mem_addr) 0x10000000)) >> 2]; else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000) && !(_addr_ & 0x3)) tmp = stack_seg [(_addr_ - stack_bot) >> 2]; else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top && !(_addr_ & 0x3)) tmp = k_data_seg [(_addr_ - ((mem_addr) 0x90000000)) >> 2]; else tmp = bad_mem_read (_addr_, 0x3, (mem_word *)&tmp);}; *( 			 &R[(inst)->r_t.r_i.rt]) = tmp & ( 0xffffffff); };
	      break;

	    case 354:
	    case 356:
	    case 357:
	      
# 410 "run.c.orig" 
{reg_word tmp; {register mem_addr _addr_ = (mem_addr) ( ( R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm)); if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top && !(_addr_ & 0x3)) tmp = data_seg [(_addr_ - ((mem_addr) 0x10000000)) >> 2]; else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000) && !(_addr_ & 0x3)) tmp = stack_seg [(_addr_ - stack_bot) >> 2]; else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top && !(_addr_ & 0x3)) tmp = k_data_seg [(_addr_ - ((mem_addr) 0x90000000)) >> 2]; else tmp = bad_mem_read (_addr_, 0x3, (mem_word *)&tmp);}; *( 			 &CPR[(inst)->opcode - 354][(inst)->r_t.r_i.rt]) = tmp & ( 			 0xffffffff); };
	      break;

	    case 358:
	      {
		register mem_addr addr = R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm;
		reg_word word;	
		register int byte = addr & 0x3;
		reg_word reg_val = R[(inst)->r_t.r_i.rt];

		
# 421 "run.c.orig" 
{reg_word tmp; {register mem_addr _addr_ = (mem_addr) ( ( addr & 0xfffffffc)); if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top && !(_addr_ & 0x3)) tmp = data_seg [(_addr_ - ((mem_addr) 0x10000000)) >> 2]; else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000) && !(_addr_ & 0x3)) tmp = stack_seg [(_addr_ - stack_bot) >> 2]; else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top && !(_addr_ & 0x3)) tmp = k_data_seg [(_addr_ - ((mem_addr) 0x90000000)) >> 2]; else tmp = bad_mem_read (_addr_, 0x3, (mem_word *)&tmp);}; *( &word) = tmp & ( 			   0xffffffff); };
		if (bare_machine) {  if (delayed_addr2 != 0) *delayed_addr2 = delayed_value2; delayed_addr2 = delayed_addr1; delayed_value2 = delayed_value1; delayed_addr1 = 0; };

		if ((!exception_occurred) || (((CPR[0][13]) >> 2) > 17))
# 444 "run.c.orig" 

		switch (byte)
		  {
		  case 0:
		    R[(inst)->r_t.r_i.rt] = (word & 0xff) << 24 | (reg_val & 0xffffff);
		    break;

		  case 1:
		    R[(inst)->r_t.r_i.rt] = (word & 0xffff) << 16 | (reg_val & 0xffff);
		    break;

		  case 2:
		    R[(inst)->r_t.r_i.rt] = (word & 0xffffff) << 8 | (reg_val & 0xff);
		    break;

		  case 3:
		    R[(inst)->r_t.r_i.rt] = word;
		    break;
		  }

		break;
	      }

	    case 359:
	      {
		register mem_addr addr = R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm;
		reg_word word;	
		register int byte = addr & 0x3;
		reg_word reg_val = R[(inst)->r_t.r_i.rt];

		{reg_word tmp; {register mem_addr _addr_ = (mem_addr) ( ( addr & 0xfffffffc)); if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top && !(_addr_ & 0x3)) tmp = data_seg [(_addr_ - ((mem_addr) 0x10000000)) >> 2]; else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000) && !(_addr_ & 0x3)) tmp = stack_seg [(_addr_ - stack_bot) >> 2]; else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top && !(_addr_ & 0x3)) tmp = k_data_seg [(_addr_ - ((mem_addr) 0x90000000)) >> 2]; else tmp = bad_mem_read (_addr_, 0x3, (mem_word *)&tmp);}; *( &word) = tmp & ( 0xffffffff); };
		if (bare_machine) {  if (delayed_addr2 != 0) *delayed_addr2 = delayed_value2; delayed_addr2 = delayed_addr1; delayed_value2 = delayed_value1; delayed_addr1 = 0; };

		if ((!exception_occurred) || (((CPR[0][13]) >> 2) > 17))
# 500 "run.c.orig" 

		switch (byte)
		  {
		    

		  case 0:	
		    R[(inst)->r_t.r_i.rt] = word;
		    break;

		  case 1:	
		    R[(inst)->r_t.r_i.rt] = (reg_val & 0xff000000)
		      | ((word & 0xffffff00) >> 8);
		    break;

		  case 2:	
		    R[(inst)->r_t.r_i.rt] = (reg_val & 0xffff0000)
		      | ((word & 0xffff0000) >> 16);
		    break;

		  case 3:	
		    R[(inst)->r_t.r_i.rt] = (reg_val & 0xffffff00)
		      | ((word & 0xff000000) >> 24);
		    break;
		  }

		break;
	      }

	    case 361:
	    case 363:
	    case 364:
	      R[(inst)->r_t.r_i.rt] = CPR[(inst)->opcode - 361][(inst)->r_t.r_i.r_i.r.rd];
	      break;

	    case 365:
	      R[(inst)->r_t.r_i.r_i.r.rd] = HI;
	      break;

	    case 366:
	      R[(inst)->r_t.r_i.r_i.r.rd] = LO;
	      break;

	    case 369:
	    case 371:
	    case 372:
	      CPR[(inst)->opcode - 369][(inst)->r_t.r_i.r_i.r.rd] = R[(inst)->r_t.r_i.rt];
	      break;

	    case 373:
	      HI = R[(inst)->r_t.r_i.rs];
	      break;

	    case 374:
	      LO = R[(inst)->r_t.r_i.rs];
	      break;

	    case 376:
	      {
		reg_word v1 = R[(inst)->r_t.r_i.rs], v2 = R[(inst)->r_t.r_i.rt];
		int neg_sign = 0;

		if (v1 < 0)
		  v1 = - v1, neg_sign = 1;
		if (v2 < 0)
		  v2 = - v2, neg_sign = ! neg_sign;

		long_multiply (v1, v2);
		if (neg_sign)
		  {
		    LO = ~ LO;
		    HI = ~ HI;
		    LO += 1;
		    if (LO == 0)
		      HI += 1;
		  }
	      }
	      break;

	    case 375:
	      long_multiply (R[(inst)->r_t.r_i.rs], R[(inst)->r_t.r_i.rt]);
	      break;

	    case 381:
	      R[(inst)->r_t.r_i.r_i.r.rd] = ~ (R[(inst)->r_t.r_i.rs] | R[(inst)->r_t.r_i.rt]);
	      break;

	    case 383:
	      R[(inst)->r_t.r_i.r_i.r.rd] = R[(inst)->r_t.r_i.rs] | R[(inst)->r_t.r_i.rt];
	      break;

	    case 382:
	      R[(inst)->r_t.r_i.rt] = R[(inst)->r_t.r_i.rs] | (0xffff & (inst)->r_t.r_i.r_i.imm);
	      break;

	    case 385:
	      (CPR[0][12]) = ((CPR[0][12]) & 0xfffffff0) | (((CPR[0][12]) & 0x3c) >> 2);
	      break;

	    case 386:
	      {register mem_addr _addr_ = (mem_addr) (R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm); data_modified = 1; if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top) data_seg_b [_addr_ - ((mem_addr) 0x10000000)] = (unsigned char) ( R[(inst)->r_t.r_i.rt]); else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000)) stack_seg_b [_addr_ - stack_bot] = (unsigned char) ( R[(inst)->r_t.r_i.rt]); else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top) k_data_seg_b [_addr_ - ((mem_addr) 0x90000000)] = (unsigned char) ( R[(inst)->r_t.r_i.rt]); else bad_mem_write (_addr_,  R[(inst)->r_t.r_i.rt], 0);};
	      break;

	    case 387:
	      {register mem_addr _addr_ = (mem_addr) (R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm); data_modified = 1; if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top && !(_addr_ & 0x1)) data_seg_h [(_addr_ - ((mem_addr) 0x10000000)) >> 1] = (unsigned short) ( R[(inst)->r_t.r_i.rt]); else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000) && !(_addr_ & 0x1)) stack_seg_h [(_addr_ - stack_bot) >> 1] = (unsigned short) ( R[(inst)->r_t.r_i.rt]); else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top && !(_addr_ & 0x1)) k_data_seg_h [(_addr_ - ((mem_addr) 0x90000000)) >> 1] = (unsigned short) ( R[(inst)->r_t.r_i.rt]); else bad_mem_write (_addr_,  R[(inst)->r_t.r_i.rt], 0x1);};
	      break;

	    case 389:
	      {
		int shamt = (inst)->r_t.r_i.r_i.r.shamt;

		if (shamt >= 0 && shamt < 32)
		  R[(inst)->r_t.r_i.r_i.r.rd] = R[(inst)->r_t.r_i.rt] << shamt;
		else
		  R[(inst)->r_t.r_i.r_i.r.rd] = R[(inst)->r_t.r_i.rt];
		break;
	      }

	    case 388:
	      {
		int shamt = (R[(inst)->r_t.r_i.rs] & 0x1f);

		if (shamt >= 0 && shamt < 32)
		  R[(inst)->r_t.r_i.r_i.r.rd] = R[(inst)->r_t.r_i.rt] << shamt;
		else
		  R[(inst)->r_t.r_i.r_i.r.rd] = R[(inst)->r_t.r_i.rt];
		break;
	      }

	    case 393:
	      if (R[(inst)->r_t.r_i.rs] < R[(inst)->r_t.r_i.rt])
		R[(inst)->r_t.r_i.r_i.r.rd] = 1;
	      else
		R[(inst)->r_t.r_i.r_i.r.rd] = 0;
	      break;

	    case 391:
	      if (R[(inst)->r_t.r_i.rs] < (short) (inst)->r_t.r_i.r_i.imm)
		R[(inst)->r_t.r_i.rt] = 1;
	      else
		R[(inst)->r_t.r_i.rt] = 0;
	      break;

	    case 390:
	      {
		int x = (short) (inst)->r_t.r_i.r_i.imm;

		if ((u_reg_word) R[(inst)->r_t.r_i.rs] < (u_reg_word) x)
		  R[(inst)->r_t.r_i.rt] = 1;
		else
		  R[(inst)->r_t.r_i.rt] = 0;
		break;
	      }

	    case 392:
	      if ((u_reg_word) R[(inst)->r_t.r_i.rs] < (u_reg_word) R[(inst)->r_t.r_i.rt])
		R[(inst)->r_t.r_i.r_i.r.rd] = 1;
	      else
		R[(inst)->r_t.r_i.r_i.r.rd] = 0;
	      break;

	    case 395:
	      {
		int shamt = (inst)->r_t.r_i.r_i.r.shamt;
		reg_word val = R[(inst)->r_t.r_i.rt];

		if (shamt >= 0 && shamt < 32)
		  R[(inst)->r_t.r_i.r_i.r.rd] = val >> shamt;
		else
		  R[(inst)->r_t.r_i.r_i.r.rd] = val;
		break;
	      }

	    case 394:
	      {
		int shamt = R[(inst)->r_t.r_i.rs] & 0x1f;
		reg_word val = R[(inst)->r_t.r_i.rt];

		if (shamt >= 0 && shamt < 32)
		  R[(inst)->r_t.r_i.r_i.r.rd] = val >> shamt;
		else
		  R[(inst)->r_t.r_i.r_i.r.rd] = val;
		break;
	      }

	    case 397:
	      {
		int shamt = (inst)->r_t.r_i.r_i.r.shamt;
		u_reg_word val = R[(inst)->r_t.r_i.rt];

		if (shamt >= 0 && shamt < 32)
		  R[(inst)->r_t.r_i.r_i.r.rd] = val >> shamt;
		else
		  R[(inst)->r_t.r_i.r_i.r.rd] = val;
		break;
	      }

	    case 396:
	      {
		int shamt = R[(inst)->r_t.r_i.rs] & 0x1f;
		u_reg_word val = R[(inst)->r_t.r_i.rt];

		if (shamt >= 0 && shamt < 32)
		  R[(inst)->r_t.r_i.r_i.r.rd] = val >> shamt;
		else
		  R[(inst)->r_t.r_i.r_i.r.rd] = val;
		break;
	      }

	    case 400:
	      {
		register reg_word vs = R[(inst)->r_t.r_i.rs], vt = R[(inst)->r_t.r_i.rt];
		register reg_word diff = vs - vt;

		if (((vs) & 0x80000000) != ((vt) & 0x80000000)
		    && ((vs) & 0x80000000) != ((diff) & 0x80000000))
		  { if (((12)<= 17) || ((CPR[0][12]) & 0x1)) { (CPR[0][13]) = (12) << 2; exception_occurred = 1; (CPR[0][14]) = PC; (CPR[0][12]) = ((CPR[0][12]) & 0xffffffc0) | (((CPR[0][12]) & 0xf) << 2);  break; } };
		R[(inst)->r_t.r_i.r_i.r.rd] = diff;
		break;
	      }

	    case 398:
	      R[(inst)->r_t.r_i.r_i.r.rd] = (u_reg_word)R[(inst)->r_t.r_i.rs]-(u_reg_word)R[(inst)->r_t.r_i.rt];
	      break;

	    case 408:
	      {register mem_addr _addr_ = (mem_addr) (R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm); data_modified = 1; if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top && !(_addr_ & 0x3)) data_seg [(_addr_ - ((mem_addr) 0x10000000)) >> 2] = (mem_word) ( R[(inst)->r_t.r_i.rt]); else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000) && !(_addr_ & 0x3)) stack_seg [(_addr_ - stack_bot) >> 2] = (mem_word) ( R[(inst)->r_t.r_i.rt]); else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top && !(_addr_ & 0x3)) k_data_seg [(_addr_ - ((mem_addr) 0x90000000)) >> 2] = (mem_word) ( R[(inst)->r_t.r_i.rt]); else bad_mem_write (_addr_,  R[(inst)->r_t.r_i.rt], 0x3);};
	      break;

	    case 402:
	    case 404:
	    case 405:
	      
# 732 "run.c.orig" 
{register mem_addr _addr_ = (mem_addr) (R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm); data_modified = 1; if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top && !(_addr_ & 0x3)) data_seg [(_addr_ - ((mem_addr) 0x10000000)) >> 2] = (mem_word) ( 			    CPR[(inst)->opcode - 402][(inst)->r_t.r_i.rt]); else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000) && !(_addr_ & 0x3)) stack_seg [(_addr_ - stack_bot) >> 2] = (mem_word) ( 			    CPR[(inst)->opcode - 402][(inst)->r_t.r_i.rt]); else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top && !(_addr_ & 0x3)) k_data_seg [(_addr_ - ((mem_addr) 0x90000000)) >> 2] = (mem_word) ( 			    CPR[(inst)->opcode - 402][(inst)->r_t.r_i.rt]); else bad_mem_write (_addr_,  			    CPR[(inst)->opcode - 402][(inst)->r_t.r_i.rt], 0x3);};
	      break;

	    case 406:
	      {
		register mem_addr addr = R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm;
		mem_word data;
		reg_word reg = R[(inst)->r_t.r_i.rt];
		register int byte = addr & 0x3;

		{register mem_addr _addr_ = (mem_addr) ( (addr & 0xfffffffc)); if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top && !(_addr_ & 0x3)) data = data_seg [(_addr_ - ((mem_addr) 0x10000000)) >> 2]; else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000) && !(_addr_ & 0x3)) data = stack_seg [(_addr_ - stack_bot) >> 2]; else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top && !(_addr_ & 0x3)) data = k_data_seg [(_addr_ - ((mem_addr) 0x90000000)) >> 2]; else data = bad_mem_read (_addr_, 0x3, (mem_word *)&data);};
# 762 "run.c.orig" 

		switch (byte)
		  {
		  case 0:
		    data = (data & 0xffffff00) | (reg >> 24 & 0xff);
		    break;

		  case 1:
		    data = (data & 0xffff0000) | (reg >> 16 & 0xffff);
		    break;

		  case 2:
		    data = (data & 0xff000000) | (reg >> 8 & 0xffffff);
		    break;

		  case 3:
		    data = reg;
		    break;
		  }

		{register mem_addr _addr_ = (mem_addr) (addr & 0xfffffffc); data_modified = 1; if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top && !(_addr_ & 0x3)) data_seg [(_addr_ - ((mem_addr) 0x10000000)) >> 2] = (mem_word) ( data); else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000) && !(_addr_ & 0x3)) stack_seg [(_addr_ - stack_bot) >> 2] = (mem_word) ( data); else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top && !(_addr_ & 0x3)) k_data_seg [(_addr_ - ((mem_addr) 0x90000000)) >> 2] = (mem_word) ( data); else bad_mem_write (_addr_,  data, 0x3);};
		break;
	      }

	    case 407:
	      {
		register mem_addr addr = R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm;
		mem_word data;
		reg_word reg = R[(inst)->r_t.r_i.rt];
		register int byte = addr & 0x3;

		{register mem_addr _addr_ = (mem_addr) ( (addr & 0xfffffffc)); if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top && !(_addr_ & 0x3)) data = data_seg [(_addr_ - ((mem_addr) 0x10000000)) >> 2]; else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000) && !(_addr_ & 0x3)) data = stack_seg [(_addr_ - stack_bot) >> 2]; else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top && !(_addr_ & 0x3)) data = k_data_seg [(_addr_ - ((mem_addr) 0x90000000)) >> 2]; else data = bad_mem_read (_addr_, 0x3, (mem_word *)&data);};
# 813 "run.c.orig" 

		switch (byte)
		  {
		  case 0:
		    data = reg;
		    break;

		  case 1:
		    data = ((reg << 8) & 0xffffff00) | (data & 0xff) ;
		    break;

		  case 2:
		    data = ((reg << 16) & 0xffff0000) | (data & 0xffff);
		    break;

		  case 3:
		    data = ((reg << 24) & 0xff000000) | (data & 0xffffff);
		    break;
		  }

		{register mem_addr _addr_ = (mem_addr) (addr & 0xfffffffc); data_modified = 1; if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top && !(_addr_ & 0x3)) data_seg [(_addr_ - ((mem_addr) 0x10000000)) >> 2] = (mem_word) ( data); else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000) && !(_addr_ & 0x3)) stack_seg [(_addr_ - stack_bot) >> 2] = (mem_word) ( data); else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top && !(_addr_ & 0x3)) k_data_seg [(_addr_ - ((mem_addr) 0x90000000)) >> 2] = (mem_word) ( data); else bad_mem_write (_addr_,  data, 0x3);};
		break;
	      }

	    case 409:
	      if (!do_syscall ())
		return (0);
	      break;

	    case 410:
	    case 411:
	    case 412:
	    case 413:
	      fatal_error ("Unimplemented operation\n");
	      break;

	    case 415:
	      R[(inst)->r_t.r_i.r_i.r.rd] = R[(inst)->r_t.r_i.rs] ^ R[(inst)->r_t.r_i.rt];
	      break;

	    case 414:
	      R[(inst)->r_t.r_i.rt] = R[(inst)->r_t.r_i.rs] ^ (0xffff & (inst)->r_t.r_i.r_i.imm);
	      break;


	      


	    case 265:
	      {if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FGR[(inst)->r_t.r_i.r_i.r.rd] = (double) ( fabs (((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FGR[(inst)->r_t.r_i.rs])));};
	      break;

	    case 264:
	      {if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FPR[((inst)->r_t.r_i.r_i.r.rd) >> 1] = (double) ( fabs ((double) ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FPR[((inst)->r_t.r_i.rs) >> 1])));};
	      break;

	    case 271:
	      {if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FGR[(inst)->r_t.r_i.r_i.r.rd] = (double) ( ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FGR[(inst)->r_t.r_i.rs]) + ((((inst)->r_t.r_i.rt) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FGR[(inst)->r_t.r_i.rt]));};
	      
	      break;

	    case 269:
	      {if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FPR[((inst)->r_t.r_i.r_i.r.rd) >> 1] = (double) ( (double) ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FPR[((inst)->r_t.r_i.rs) >> 1]) + (double) ((((inst)->r_t.r_i.rt) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FPR[((inst)->r_t.r_i.rt) >> 1]));};
	      
	      break;

	    case 276:
	      
# 881 "run.c.orig" 
{if ((CPR[1][31]) == 0) { mem_addr target = ( 			   PC + ((((inst)->r_t.r_i.r_i.imm) & 0x8000 ? ((inst)->r_t.r_i.r_i.imm) | 0xffff0000 : ((inst)->r_t.r_i.r_i.imm)) << 2)); if (bare_machine)  target += 4; {if (bare_machine) run_spim (PC + 4, 1, display);  PC = (target) - 4; } } };
	      break;

	    case 277:
	      
# 886 "run.c.orig" 
{if ((CPR[1][31]) == 1) { mem_addr target = ( 			   PC + ((((inst)->r_t.r_i.r_i.imm) & 0x8000 ? ((inst)->r_t.r_i.r_i.imm) | 0xffff0000 : ((inst)->r_t.r_i.r_i.imm)) << 2)); if (bare_machine)  target += 4; {if (bare_machine) run_spim (PC + 4, 1, display);  PC = (target) - 4; } } };
	      break;

	    case 312:
	    case 340:
	    case 310:
	    case 334:
	    case 326:
	    case 328:
	    case 336:
	    case 338:
	    case 332:
	    case 320:
	    case 330:
	    case 322:
	    case 316:
	    case 318:
	    case 314:
	    case 324:
	      {
		float v1 = ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FGR[(inst)->r_t.r_i.rs]), v2 = ((((inst)->r_t.r_i.rt) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FGR[(inst)->r_t.r_i.rt]);
		double dv1 = v1, dv2 = v2;
		int less, equal, unordered;
		int cond = (inst)->r_t.r_i.r_i.imm;

		if (0 || 0)
		  {
		    less = 0;
		    equal = 0;
		    unordered = 1;
		    if (cond & 0x8)
		      { if (((14)<= 17) || ((CPR[0][12]) & 0x1)) { (CPR[0][13]) = (14) << 2; exception_occurred = 1; (CPR[0][14]) = PC; (CPR[0][12]) = ((CPR[0][12]) & 0xffffffc0) | (((CPR[0][12]) & 0xf) << 2);  break; } };
		  }
		else
		  {
		    less = v1 < v2;
		    equal = v1 == v2;
		    unordered = 0;
		  }
		(CPR[1][31]) = 0;
		if (cond & 0x4)
		  (CPR[1][31]) |= less;
		if (cond & 0x2)
		  (CPR[1][31]) |= equal;
		if (cond & 0x1)
		  (CPR[1][31]) |= unordered;
	      }
	      break;

	    case 311:
	    case 339:
	    case 309:
	    case 333:
	    case 325:
	    case 327:
	    case 335:
	    case 337:
	    case 331:
	    case 319:
	    case 329:
	    case 321:
	    case 315:
	    case 317:
	    case 313:
	    case 323:
	      {
		double v1 = (double) ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FPR[((inst)->r_t.r_i.rs) >> 1]), v2 = (double) ((((inst)->r_t.r_i.rt) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FPR[((inst)->r_t.r_i.rt) >> 1]);
		int less, equal, unordered;
		int cond = (inst)->r_t.r_i.r_i.imm;

		if (0 || 0)
		  {
		    less = 0;
		    equal = 0;
		    unordered = 1;
		    if (cond & 0x8)
		      { if (((14)<= 17) || ((CPR[0][12]) & 0x1)) { (CPR[0][13]) = (14) << 2; exception_occurred = 1; (CPR[0][14]) = PC; (CPR[0][12]) = ((CPR[0][12]) & 0xffffffc0) | (((CPR[0][12]) & 0xf) << 2);  break; } };
		  }
		else
		  {
		    less = v1 < v2;
		    equal = v1 == v2;
		    unordered = 0;
		  }
		(CPR[1][31]) = 0;
		if (cond & 0x4)
		  (CPR[1][31]) |= less;
		if (cond & 0x2)
		  (CPR[1][31]) |= equal;
		if (cond & 0x1)
		  (CPR[1][31]) |= unordered;
	      }
	      break;

	    case 292:
	      R[(inst)->r_t.r_i.rt] = CPR[1][(inst)->r_t.r_i.r_i.r.rd]; 
	      break;

	    case 300:
	      CPR[1][(inst)->r_t.r_i.r_i.r.rd] = R[(inst)->r_t.r_i.rt]; 
	      break;

	    case 303:
	      {
		double val = ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FGR[(inst)->r_t.r_i.rs]);

		{if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FPR[((inst)->r_t.r_i.r_i.r.rd) >> 1] = (double) ( val);};
		break;
	      }

	    case 304:
	      {
		double val = (FWR[(inst)->r_t.r_i.rs]);

		{if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FPR[((inst)->r_t.r_i.r_i.r.rd) >> 1] = (double) ( val);};
		break;
	      }

	    case 305:
	      {
		float val = (double) ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FPR[((inst)->r_t.r_i.rs) >> 1]);

		{if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FGR[(inst)->r_t.r_i.r_i.r.rd] = (double) ( val);};
		break;
	      }

	    case 306:
	      {
		float val = (FWR[(inst)->r_t.r_i.rs]);

		{if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FGR[(inst)->r_t.r_i.r_i.r.rd] = (double) ( val);};
		break;
	      }

	    case 307:
	      {
		int val = (double) ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FPR[((inst)->r_t.r_i.rs) >> 1]);

		{FWR[(inst)->r_t.r_i.r_i.r.rd] = (int) ( val);};
		break;
	      }

	    case 308:
	      {
		int val = ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FGR[(inst)->r_t.r_i.rs]);

		{FWR[(inst)->r_t.r_i.r_i.r.rd] = (int) ( val);};
		break;
	      }

	    case 344:
	      {if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FGR[(inst)->r_t.r_i.r_i.r.rd] = (double) ( ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FGR[(inst)->r_t.r_i.rs]) / ((((inst)->r_t.r_i.rt) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FGR[(inst)->r_t.r_i.rt]));};
	      break;

	    case 342:
	      {if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FPR[((inst)->r_t.r_i.r_i.r.rd) >> 1] = (double) ( (double) ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FPR[((inst)->r_t.r_i.rs) >> 1]) / (double) ((((inst)->r_t.r_i.rt) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FPR[((inst)->r_t.r_i.rt) >> 1]));};
	      break;

	    case 355:
	      {
		reg_word *wp = (reg_word *) &FGR[(inst)->r_t.r_i.rt];

		
# 1049 "run.c.orig" 
{reg_word tmp; {register mem_addr _addr_ = (mem_addr) ( ( R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm)); if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top && !(_addr_ & 0x3)) tmp = data_seg [(_addr_ - ((mem_addr) 0x10000000)) >> 2]; else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000) && !(_addr_ & 0x3)) tmp = stack_seg [(_addr_ - stack_bot) >> 2]; else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top && !(_addr_ & 0x3)) tmp = k_data_seg [(_addr_ - ((mem_addr) 0x90000000)) >> 2]; else tmp = bad_mem_read (_addr_, 0x3, (mem_word *)&tmp);}; *( wp) = tmp & ( 			   0xffffffff); };
		break;
	      }

	    case 362:
	      {
		float val = FGR[(inst)->r_t.r_i.r_i.r.rd]; 
		reg_word *vp = (reg_word *) &val;

		R[(inst)->r_t.r_i.rt] = *vp; 
		break;
	      }

	    case 368:
	      {if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FGR[(inst)->r_t.r_i.r_i.r.rd] = (double) ( ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FGR[(inst)->r_t.r_i.rs]));};
	      break;

	    case 367:
	      {if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FPR[((inst)->r_t.r_i.r_i.r.rd) >> 1] = (double) ( (double) ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FPR[((inst)->r_t.r_i.rs) >> 1]));};
	      break;

	    case 370:
	      {
		reg_word word = R[(inst)->r_t.r_i.rt];
		float *wp = (float *) &word;

		FGR[(inst)->r_t.r_i.r_i.r.rd] = *wp; 
		break;
	      }

	    case 378:
	      {if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FGR[(inst)->r_t.r_i.r_i.r.rd] = (double) ( ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FGR[(inst)->r_t.r_i.rs]) * ((((inst)->r_t.r_i.rt) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FGR[(inst)->r_t.r_i.rt]));};
	      break;

	    case 377:
	      {if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FPR[((inst)->r_t.r_i.r_i.r.rd) >> 1] = (double) ( (double) ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FPR[((inst)->r_t.r_i.rs) >> 1]) * (double) ((((inst)->r_t.r_i.rt) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FPR[((inst)->r_t.r_i.rt) >> 1]));};
	      break;

	    case 380:
	      {if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FGR[(inst)->r_t.r_i.r_i.r.rd] = (double) ( -((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FGR[(inst)->r_t.r_i.rs]));};
	      break;

	    case 379:
	      {if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FPR[((inst)->r_t.r_i.r_i.r.rd) >> 1] = (double) ( -(double) ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FPR[((inst)->r_t.r_i.rs) >> 1]));};
	      break;

	    case 401:
	      {if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FGR[(inst)->r_t.r_i.r_i.r.rd] = (double) ( ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FGR[(inst)->r_t.r_i.rs]) - ((((inst)->r_t.r_i.rt) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FGR[(inst)->r_t.r_i.rt]));};
	      break;

	    case 399:
	      {if (((inst)->r_t.r_i.r_i.r.rd) & 0x1) run_error ("Bit 0 in FP reg spec\n"); else FPR[((inst)->r_t.r_i.r_i.r.rd) >> 1] = (double) ( (double) ((((inst)->r_t.r_i.rs) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FPR[((inst)->r_t.r_i.rs) >> 1]) - (double) ((((inst)->r_t.r_i.rt) & 0x1) ? (run_error ("Bit 0 in FP reg spec\n") ? 0.0 : 0.0) : FPR[((inst)->r_t.r_i.rt) >> 1]));};
	      break;

	    case 403:
	      {
		float val = FGR[(inst)->r_t.r_i.rt];
		reg_word *vp = (reg_word *) &val;

		{register mem_addr _addr_ = (mem_addr) (R[(inst)->r_t.r_i.rs] + (inst)->r_t.r_i.r_i.imm); data_modified = 1; if (_addr_ >= ((mem_addr) 0x10000000) && _addr_ < data_top && !(_addr_ & 0x3)) data_seg [(_addr_ - ((mem_addr) 0x10000000)) >> 2] = (mem_word) ( *vp); else if (_addr_ >= stack_bot && _addr_ < ((mem_addr) 0x80000000) && !(_addr_ & 0x3)) stack_seg [(_addr_ - stack_bot) >> 2] = (mem_word) ( *vp); else if (_addr_ >= ((mem_addr) 0x90000000) && _addr_ < k_data_top && !(_addr_ & 0x3)) k_data_seg [(_addr_ - ((mem_addr) 0x90000000)) >> 2] = (mem_word) ( *vp); else bad_mem_write (_addr_,  *vp, 0x3);};
		break;
	      }

	    default:
	      fatal_error ("Unknown instruction type: %d\n", (inst)->opcode);
	      break;
	    }

	  
	  PC += 4;

	  if (exception_occurred)
	    {
	      if (((CPR[0][13]) >> 2) > 17)
		(CPR[0][14]) = PC - 4;

	      handle_exception ();
	    }
	}			
    }				

  
  return (1);
}
















# 1152 "run.c.orig" 

static void
long_multiply (v1, v2)
     reg_word v1, v2;

{
  register u_reg_word a, b, c, d;
  register u_reg_word bd, ad, cb, ac;
  register u_reg_word mid, mid2, carry_mid = 0;

  a = (v1 >> 16) & 0xffff;
  b = v1 & 0xffff;
  c = (v2 >> 16) & 0xffff;
  d = v2 & 0xffff;

  bd = b * d;
  ad = a * d;
  cb = c * b;
  ac = a * c;

  mid = ad + cb;
  if (mid < ad || mid < cb)
    
    carry_mid = 1;

  mid2 = mid + ((bd >> 16) & 0xffff);
  if (mid2 < mid || mid2 < ((bd >> 16) & 0xffff))
    
    carry_mid += 1;

  LO = (bd & 0xffff) | ((mid2 & 0xffff) << 16);
  HI = ac + (carry_mid << 16) + ((mid2 >> 16) & 0xffff);
}
